#include "events.h"
#include "framedata.h"
#include "lists.h"
#include "media.h"
#include "objects.h"
#include "bitarray.h"

void Frames::event_func_1181()
{
    // event 8_7
    {
        // group: None
        every_8_7_0 += manager.dt;
        if (every_8_7_0 < 1.0) goto event_8_7_end;
        every_8_7_0 -= 1.0;
        ((Text*)get_instance(string7_0_instances))->next_paragraph();
    }
    event_8_7_end: ;
}
void Frames::handle_frame_8_events()
{
    test_collisions_7();
    if (next_frame != -1) return;
    event_func_1180();
    event_func_4();
    event_func_5();
    event_func_6();
    event_func_1181();
}
void Frames::handle_frame_8_pre_events()
{
    event_func_1178();
    event_func_1179();
}
void Frames::event_func_1182()
{
    // event 4_7
    {
        media.stop_samples();
    }
    event_4_7_end: ;
}
void Frames::on_frame_8_start_events()
{
    event_func_1182();
}
void Frames::on_frame_8_init()
{
    index = 7;
    width = 640;
    height = 360;
    virtual_width = 640;
    virtual_height = 360;
    background_color = Color(0, 0, 0);
    timer_base = 0;
    reset_image_cache();
    flush_image_cache();
    layers.resize(1);
    layers[0].init(0, 1.0, 1.0, true, false, false);
    #ifdef CHOWDREN_HAS_MRT
    #endif
    #ifdef CHOWDREN_IS_3DS
    #endif
    add_object(create_string2_302(160, -160), 0);
    add_object(create_string3_303(160, 48), 0);
    add_object(create_string4_304(48, 80), 0);
    add_object(create_string6_306(432, 80), 0);
    add_object(create_string5_305(240, 80), 0);
    add_object(create_active_307(270, 12), 0);
    add_object(create_active2_308(-5, 6), 0);
    add_object(create_active3_309(-281, 3), 0);
    add_object(create_active4_310(-54, 5), 0);
    add_object(create_string7_311(480, 320), 0);
    add_object(create_overlay2_22(0, 0), 0);
    loops = NULL;
    every_8_7_0 = 0.0f;
    not_always_7_0_0 = loop_count;
    not_always_6_0_0 = loop_count;
    not_always_5_0_0 = loop_count;
}
void Frames::test_collisions_8()
{
    ObjectList::iterator it1, it2;
}
void Frames::event_func_1183()
{
    // event 1_8
    {
        // group: None
        active2_2_instances.clear_selection();
        for (ObjectIterator it(active2_2_instances); !it.end(); ++it) {
            ((Active*)*it)->set_x(randrange_event(640)-64);
            ((Active*)*it)->set_y(randrange_event(360)-64);
        }
    }
    event_1_8_end: ;
}
void Frames::event_func_1184()
{
    // event 2_8
    {
        // group: None
        active2_2_instances.clear_selection();
        for (ObjectIterator it(active2_2_instances); !it.end(); ++it) {
            ((Active*)*it)->force_frame(randrange_event(7));
        }
        media.set_sample_volume(SOUND_BWEN_23, 0.4*global_values->get(12));
    }
    event_2_8_end: ;
}
void Frames::event_func_1185()
{
    // event 4_8
    {
        // group: None
        if (!(frame_time >= 3.0)) goto event_4_8_end;
        if (!(is_player_pressed_once(1, CONTROL_LEFT))) goto event_4_8_end;
        if (!((((Active*)get_instance(devil_312_instances))->alterables->values.get(0)) == (0))) goto event_4_8_end;
        ((Active*)get_instance(devil_312_instances))->alterables->values.set(0, 1); // 'Devil'
        media.stop_sample(SOUND_BWEN_23);
        media.play_id(SOUND_BWEN_23, -1, 1);
        media.set_sample_volume(SOUND_BWEN_23, global_values->get(12)*0.5);
    }
    event_4_8_end: ;
}
void Frames::event_func_1186()
{
    // event 5_8
    {
        // group: None
        if (!(frame_time >= 3.0)) goto event_5_8_end;
        if (!(is_player_pressed_once(1, CONTROL_RIGHT))) goto event_5_8_end;
        if (!((((Active*)get_instance(devil_312_instances))->alterables->values.get(0)) == (1))) goto event_5_8_end;
        ((Active*)get_instance(devil_312_instances))->alterables->values.set(0, 0); // 'Devil'
        media.stop_sample(SOUND_BWEN_23);
        media.play_id(SOUND_BWEN_23, -1, 1);
        media.set_sample_volume(SOUND_BWEN_23, global_values->get(12)*0.5);
    }
    event_5_8_end: ;
}
void Frames::event_func_1187()
{
    // event 6_8
    {
        // group: None
        if (frame_time < 3.0) goto event_6_8_end;
        if (not_always_6_8_0 > loop_count) {
            not_always_6_8_0 = loop_count + 2;
            goto event_6_8_end;
        }
        not_always_6_8_0 = loop_count + 2;
        ((Text*)get_instance(string6_79_instances))->set_visible(true);
        ((Text*)get_instance(string5_61_instances))->set_visible(true);
        ((Active*)get_instance(active5_6_instances))->set_visible(true);
        ((Active*)get_instance(active4_5_instances))->set_visible(true);
        ((Active*)get_instance(active3_4_instances))->set_visible(true);
        ((Active*)get_instance(active25_74_instances))->set_visible(true);
    }
    event_6_8_end: ;
}
void Frames::event_func_1188()
{
    // event 7_8
    {
        // group: None
        if (!((((Active*)get_instance(devil_312_instances))->alterables->values.get(0)) == (0))) goto event_7_8_end;
        ((Active*)get_instance(active25_74_instances))->set_x(319);
        ((Active*)get_instance(active25_74_instances))->set_y(325);
    }
    event_7_8_end: ;
}
void Frames::event_func_1189()
{
    // event 8_8
    {
        // group: None
        if (!((((Active*)get_instance(devil_312_instances))->alterables->values.get(0)) == (1))) goto event_8_8_end;
        ((Active*)get_instance(active25_74_instances))->set_x(256);
        ((Active*)get_instance(active25_74_instances))->set_y(325);
    }
    event_8_8_end: ;
}
void Frames::event_func_1190()
{
    // event 9_8
    {
        // group: None
        if (!(frame_time >= 3.0)) goto event_9_8_end;
        if (!(is_player_pressed_once(1, CONTROL_BUTTON1))) goto event_9_8_end;
        if (!((((Active*)get_instance(devil_312_instances))->alterables->values.get(0)) == (1))) goto event_9_8_end;
        media.stop_sample(SOUND_BWEN_23);
        media.set_sample_volume(SOUND_THWAP_01_34, global_values->get(12)*0.38);
        ((Active*)get_instance(devil_312_instances))->alterables->values.set(1, 1); // 'Devil'
        media.play_id(SOUND_THWAP_01_34, -1, 1);
        global_values->sub(17, 3);
        global_values->set(3, 1);
    }
    event_9_8_end: ;
}
void Frames::event_func_1191()
{
    // event 10_8
    {
        // group: None
        if (!(frame_time >= 3.0)) goto event_10_8_end;
        if (!(is_player_pressed_once(1, CONTROL_BUTTON1))) goto event_10_8_end;
        if (!((((Active*)get_instance(devil_312_instances))->alterables->values.get(0)) == (0))) goto event_10_8_end;
        media.stop_sample(SOUND_BWEN_23);
        media.set_sample_volume(SOUND_THWAP_01_34, global_values->get(12)*0.38);
        ((Active*)get_instance(devil_312_instances))->alterables->values.set(1, 1); // 'Devil'
        media.play_id(SOUND_THWAP_01_34, -1, 1);
        global_values->set(8, 0);
        global_values->set(9, 0);
        global_values->set(6, 0);
        global_values->set(7, 0);
    }
    event_10_8_end: ;
}
void Frames::event_func_1192()
{
    // event 11_8
    {
        // group: None
        if (!((((Active*)get_instance(devil_312_instances))->alterables->values.get(1)) == (1))) goto event_11_8_end;
        active2_2_instances.empty_selection();
        // select single: false true false
        {
            FrameObject * parent = ((Active*)get_instance(devil_312_instances));
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_313(parent->x + 0, parent->y + 0), parent->layer);
                active2_2_instances.add_back();
            }
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_313(parent->x + 0, parent->y + 0), parent->layer);
                active2_2_instances.add_back();
            }
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_313(parent->x + 0, parent->y + 0), parent->layer);
                active2_2_instances.add_back();
            }
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_313(parent->x + 0, parent->y + 0), parent->layer);
                active2_2_instances.add_back();
            }
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_313(parent->x + 0, parent->y + 0), parent->layer);
                active2_2_instances.add_back();
            }
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_313(parent->x + 0, parent->y + 0), parent->layer);
                active2_2_instances.add_back();
            }
        }
        media.stop_sample(SOUND_DEVIL_2_36);
        ((Active*)get_instance(active25_74_instances))->set_visible(false);
        ((Active*)get_instance(active3_4_instances))->set_visible(false);
        ((Active*)get_instance(active4_5_instances))->set_visible(false);
        ((Active*)get_instance(active5_6_instances))->set_visible(false);
        ((Text*)get_instance(string5_61_instances))->set_visible(false);
        ((Text*)get_instance(string6_79_instances))->set_visible(false);
        for (ObjectIterator it(active2_2_instances); !it.end(); ++it) {
            ((Active*)*it)->set_x(randrange_event(640)-64);
            ((Active*)*it)->set_y(randrange_event(360)-64);
        }
        ((Active*)get_instance(devil_312_instances))->alterables->values.add(2, 1); // 'Devil'
    }
    event_11_8_end: ;
}
void Frames::event_func_1193()
{
    // event 12_8
    {
        // group: None
        if (!((((Active*)get_instance(devil_312_instances))->alterables->values.get(2)) == (300))) goto event_12_8_end;
        next_frame = 3 + 0;    
    
        global_values->set(2, global_values->get(15));
        global_values->set(3, 0);
        global_values->set(0, 100);
        global_values->set(10, global_values->get(16));
    }
    event_12_8_end: ;
}
void Frames::handle_frame_9_events()
{
    test_collisions_8();
    event_func_1185();
    event_func_1186();
    event_func_1187();
    event_func_1190();
    event_func_1191();
    if (next_frame != -1) return;
    event_func_1183();
    event_func_1184();
    event_func_1188();
    event_func_1189();
    event_func_1192();
    event_func_1193();
}
void Frames::handle_frame_9_pre_events()
{
}
void Frames::event_func_1194()
{
    // event 3_8
    {
        media.set_sample_volume(SOUND_DEVIL_2_36, global_values->get(12)*0.2);
        media.play_id(SOUND_DEVIL_2_36, -1, 0);
        media.set_sample_volume(SOUND_DEVIL_2_36, global_values->get(12)*0.2);
        ((Active*)get_instance(active25_74_instances))->set_visible(false);
        ((Active*)get_instance(active3_4_instances))->set_visible(false);
        ((Active*)get_instance(active4_5_instances))->set_visible(false);
        ((Active*)get_instance(active5_6_instances))->set_visible(false);
        ((Text*)get_instance(string5_61_instances))->set_visible(false);
        ((Text*)get_instance(string6_79_instances))->set_visible(false);
    }
    event_3_8_end: ;
}
void Frames::on_frame_9_start_events()
{
    event_func_1194();
}
void Frames::on_frame_9_init()
{
    index = 8;
    width = 640;
    height = 360;
    virtual_width = 640;
    virtual_height = 360;
    background_color = Color(8, 0, 0);
    timer_base = 50;
    reset_image_cache();
    flush_image_cache();
    layers.resize(2);
    layers[0].init(0, 1.0, 1.0, true, false, false);
    layers[1].init(1, 1.0, 1.0, true, false, false);
    #ifdef CHOWDREN_HAS_MRT
    #endif
    #ifdef CHOWDREN_IS_3DS
    #endif
    add_object(create_devil_312(0, 0), 0);
    add_object(create_active2_313(0, 160), 0);
    add_object(create_active2_313(192, 160), 0);
    add_object(create_active2_313(256, 0), 0);
    add_object(create_active2_313(96, 32), 0);
    add_object(create_active2_313(32, 224), 0);
    add_object(create_active2_313(416, 224), 0);
    add_object(create_active2_313(320, 192), 0);
    add_object(create_active2_313(288, 96), 0);
    add_object(create_active2_313(416, 128), 0);
    add_object(create_active2_313(416, 0), 0);
    add_object(create_active2_313(544, 32), 0);
    add_object(create_active2_313(544, 192), 0);
    add_object(create_active2_313(224, 256), 0);
    add_object(create_active2_313(128, 256), 0);
    add_object(create_active2_313(96, 160), 0);
    add_object(create_active2_313(0, 96), 0);
    add_object(create_active2_313(0, 0), 0);
    add_object(create_active2_313(0, 256), 0);
    add_object(create_active2_313(416, 96), 0);
    add_object(create_active2_313(256, 96), 0);
    add_object(create_active2_313(160, 96), 0);
    add_object(create_active2_313(256, 32), 0);
    add_object(create_active2_313(384, 64), 0);
    add_object(create_active2_313(192, 64), 0);
    add_object(create_active2_313(480, 160), 0);
    add_object(create_active2_313(352, 160), 0);
    add_object(create_active2_313(32, 160), 0);
    add_object(create_active2_313(32, 32), 0);
    add_object(create_active2_313(288, 224), 0);
    add_object(create_active2_313(192, 160), 0);
    add_object(create_active2_313(320, 96), 0);
    add_object(create_active2_313(96, 96), 0);
    add_object(create_active2_313(96, 128), 0);
    add_object(create_active2_313(128, 64), 0);
    add_object(create_active2_313(416, 32), 0);
    add_object(create_active2_313(480, 0), 0);
    add_object(create_active2_313(480, 224), 0);
    add_object(create_active2_313(384, 224), 0);
    add_object(create_active2_313(192, 224), 0);
    add_object(create_active2_313(64, 224), 0);
    add_object(create_active2_313(0, 224), 0);
    add_object(create_active2_313(0, 64), 0);
    add_object(create_active2_313(0, 0), 0);
    add_object(create_active2_313(576, 64), 0);
    add_object(create_active2_313(448, 192), 0);
    add_object(create_active2_313(480, 96), 0);
    add_object(create_active2_313(352, 32), 0);
    add_object(create_active2_313(192, -32), 0);
    add_object(create_active2_313(512, 96), 0);
    add_object(create_active2_313(512, 192), 0);
    add_object(create_active2_313(192, 128), 0);
    add_object(create_active2_313(192, 192), 0);
    add_object(create_active2_313(288, 192), 0);
    add_object(create_active2_313(96, 96), 0);
    add_object(create_active2_313(288, 128), 0);
    add_object(create_active2_313(384, 128), 0);
    add_object(create_active2_313(32, 160), 0);
    add_object(create_active2_313(224, 192), 0);
    add_object(create_active2_313(320, 192), 0);
    add_object(create_active2_313(-64, 128), 0);
    add_object(create_active2_313(128, 160), 0);
    add_object(create_active2_313(224, 160), 0);
    add_object(create_active2_313(32, 64), 0);
    add_object(create_active2_313(224, 96), 0);
    add_object(create_active2_313(320, 96), 0);
    add_object(create_active2_313(-32, 128), 0);
    add_object(create_active2_313(160, 160), 0);
    add_object(create_active2_313(256, 160), 0);
    add_object(create_active2_313(320, 192), 0);
    add_object(create_active2_313(32, 160), 0);
    add_object(create_active2_313(224, 192), 0);
    add_object(create_active2_313(320, 192), 0);
    add_object(create_active2_313(128, 96), 0);
    add_object(create_active2_313(320, 128), 0);
    add_object(create_active2_313(64, 160), 0);
    add_object(create_active2_313(256, 192), 0);
    add_object(create_active2_313(352, 192), 0);
    add_object(create_active2_313(160, 160), 0);
    add_object(create_active2_313(256, 160), 0);
    add_object(create_active2_313(256, 96), 0);
    add_object(create_active2_313(352, 96), 0);
    add_object(create_active2_313(0, 128), 0);
    add_object(create_active2_313(192, 160), 0);
    add_object(create_active2_313(288, 160), 0);
    add_object(create_active2_313(352, 192), 0);
    add_object(create_active2_313(128, 160), 0);
    add_object(create_active2_313(320, 192), 0);
    add_object(create_active2_313(416, 192), 0);
    add_object(create_active2_313(224, 96), 0);
    add_object(create_active2_313(416, 128), 0);
    add_object(create_active2_313(512, 128), 0);
    add_object(create_active2_313(160, 160), 0);
    add_object(create_active2_313(352, 192), 0);
    add_object(create_active2_313(448, 192), 0);
    add_object(create_active2_313(64, 128), 0);
    add_object(create_active2_313(256, 160), 0);
    add_object(create_active2_313(352, 160), 0);
    add_object(create_active2_313(160, 64), 0);
    add_object(create_active2_313(352, 96), 0);
    add_object(create_active2_313(448, 96), 0);
    add_object(create_active2_313(96, 128), 0);
    add_object(create_active2_313(288, 160), 0);
    add_object(create_active2_313(384, 160), 0);
    add_object(create_active2_313(448, 192), 0);
    add_object(create_active2_313(160, 160), 0);
    add_object(create_active2_313(352, 192), 0);
    add_object(create_active2_313(448, 192), 0);
    add_object(create_active2_313(256, 96), 0);
    add_object(create_active2_313(448, 128), 0);
    add_object(create_active2_313(192, 160), 0);
    add_object(create_active2_313(384, 192), 0);
    add_object(create_active2_313(480, 192), 0);
    add_object(create_active2_313(288, 160), 0);
    add_object(create_active2_313(384, 160), 0);
    add_object(create_active2_313(384, 96), 0);
    add_object(create_active2_313(480, 96), 0);
    add_object(create_active2_313(128, 128), 0);
    add_object(create_active2_313(320, 160), 0);
    add_object(create_active2_313(416, 160), 0);
    add_object(create_active2_313(480, 192), 0);
    add_object(create_active2_313(160, 192), 0);
    add_object(create_active2_313(352, 224), 0);
    add_object(create_active2_313(448, 224), 0);
    add_object(create_active2_313(256, 128), 0);
    add_object(create_active2_313(448, 160), 0);
    add_object(create_active2_313(544, 160), 0);
    add_object(create_active2_313(192, 192), 0);
    add_object(create_active2_313(384, 224), 0);
    add_object(create_active2_313(480, 224), 0);
    add_object(create_active2_313(96, 160), 0);
    add_object(create_active2_313(288, 192), 0);
    add_object(create_active2_313(384, 192), 0);
    add_object(create_active2_313(192, 96), 0);
    add_object(create_active2_313(384, 128), 0);
    add_object(create_active2_313(480, 128), 0);
    add_object(create_active2_313(128, 160), 0);
    add_object(create_active2_313(320, 192), 0);
    add_object(create_active2_313(416, 192), 0);
    add_object(create_active2_313(480, 224), 0);
    add_object(create_active2_313(192, 192), 0);
    add_object(create_active2_313(384, 224), 0);
    add_object(create_active2_313(480, 224), 0);
    add_object(create_active2_313(288, 128), 0);
    add_object(create_active2_313(480, 160), 0);
    add_object(create_active2_313(224, 192), 0);
    add_object(create_active2_313(416, 224), 0);
    add_object(create_active2_313(512, 224), 0);
    add_object(create_active2_313(320, 192), 0);
    add_object(create_active2_313(416, 192), 0);
    add_object(create_active2_313(416, 128), 0);
    add_object(create_active2_313(512, 128), 0);
    add_object(create_active2_313(160, 160), 0);
    add_object(create_active2_313(352, 192), 0);
    add_object(create_active2_313(448, 192), 0);
    add_object(create_active2_313(512, 224), 0);
    add_object(create_active2_313(96, 160), 0);
    add_object(create_active2_313(288, 192), 0);
    add_object(create_active2_313(384, 192), 0);
    add_object(create_active2_313(192, 96), 0);
    add_object(create_active2_313(384, 128), 0);
    add_object(create_active2_313(480, 128), 0);
    add_object(create_active2_313(128, 160), 0);
    add_object(create_active2_313(320, 192), 0);
    add_object(create_active2_313(416, 192), 0);
    add_object(create_active2_313(32, 128), 0);
    add_object(create_active2_313(224, 160), 0);
    add_object(create_active2_313(320, 160), 0);
    add_object(create_active2_313(128, 64), 0);
    add_object(create_active2_313(320, 96), 0);
    add_object(create_active2_313(416, 96), 0);
    add_object(create_active2_313(64, 128), 0);
    add_object(create_active2_313(256, 160), 0);
    add_object(create_active2_313(352, 160), 0);
    add_object(create_active2_313(416, 192), 0);
    add_object(create_active2_313(128, 160), 0);
    add_object(create_active2_313(320, 192), 0);
    add_object(create_active2_313(416, 192), 0);
    add_object(create_active2_313(224, 96), 0);
    add_object(create_active2_313(416, 128), 0);
    add_object(create_active2_313(160, 160), 0);
    add_object(create_active2_313(352, 192), 0);
    add_object(create_active2_313(448, 192), 0);
    add_object(create_active2_313(256, 160), 0);
    add_object(create_active2_313(352, 160), 0);
    add_object(create_active2_313(352, 96), 0);
    add_object(create_active2_313(448, 96), 0);
    add_object(create_active2_313(96, 128), 0);
    add_object(create_active2_313(288, 160), 0);
    add_object(create_active2_313(384, 160), 0);
    add_object(create_active2_313(448, 192), 0);
    add_object(create_string6_315(416, -96), 0);
    add_object(create_active5_318(192, 266), 1);
    add_object(create_string5_314(231, 321), 1);
    add_object(create_active3_316(282, 339), 1);
    add_object(create_active4_317(346, 339), 1);
    add_object(create_active25_319(256, 325), 1);
    loops = NULL;
    not_always_6_8_0 = loop_count;
}
static void update_active_0(ObjectList ** lists, int count)
{
    ObjectList::iterator it;
    for (int i = 0; i < count; i++) {
        ObjectList & list = *lists[i];
        for (it = list.begin(); it != list.end(); ++it) {
            FrameObject * instance = it->obj;
            if (instance->flags & DESTROYING)
                continue;
            instance->update_inactive();
            if (instance->flags & INACTIVE)
                continue;
            ((Active*)instance)->update();
        }
    }
}
static void update_active_1(ObjectList ** lists, int count)
{
    ObjectList::iterator it;
    for (int i = 0; i < count; i++) {
        ObjectList & list = *lists[i];
        for (it = list.begin(); it != list.end(); ++it) {
            FrameObject * instance = it->obj;
            if (instance->flags & DESTROYING)
                continue;
            ((Active*)instance)->update();
        }
    }
}
static void update_active_2(ObjectList ** lists, int count)
{
    ObjectList::iterator it;
    for (int i = 0; i < count; i++) {
        ObjectList & list = *lists[i];
        for (it = list.begin(); it != list.end(); ++it) {
            FrameObject * instance = it->obj;
            if (instance->flags & DESTROYING)
                continue;
            ((Active*)instance)->update();
            if (instance->movement)
                instance->movement->update();
        }
    }
}
static void update_active_3(ObjectList ** lists, int count)
{
    ObjectList::iterator it;
    for (int i = 0; i < count; i++) {
        ObjectList & list = *lists[i];
        for (it = list.begin(); it != list.end(); ++it) {
            FrameObject * instance = it->obj;
            if (instance->flags & DESTROYING)
                continue;
            instance->update_kill();
            if (instance->flags & INACTIVE)
                continue;
            ((Active*)instance)->update();
        }
    }
}
static void update_active_4(ObjectList ** lists, int count)
{
    ObjectList::iterator it;
    for (int i = 0; i < count; i++) {
        ObjectList & list = *lists[i];
        for (it = list.begin(); it != list.end(); ++it) {
            FrameObject * instance = it->obj;
            if (instance->flags & DESTROYING)
                continue;
            instance->update_inactive();
            if (instance->flags & INACTIVE)
                continue;
            ((Active*)instance)->update();
            if (instance->movement)
                instance->movement->update();
        }
    }
}
void Frames::update_objects()
{
    update_active_4(update_active_4_list, 1);
    update_active_2(update_active_2_list, 20);
    update_active_3(update_active_3_list, 7);
    update_active_0(update_active_0_list, 51);
    update_active_1(update_active_1_list, 114);
    ObjectList * special_list[1];
    switch (index) {
        case 0:
            special_list[0] = &active9_10_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active11_12_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active6_7_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active13_14_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active15_16_instances;
            update_active_3(special_list, 1);
            special_list[0] = &active5_6_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active3_4_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active4_5_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active16_17_instances;
            update_active_3(special_list, 1);
            special_list[0] = &active8_9_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active2_2_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active7_8_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active_1_instances;
            update_active_0(special_list, 1);
            break;
        case 1:
            special_list[0] = &active6_7_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active4_5_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active2_2_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active_1_instances;
            update_active_0(special_list, 1);
            break;
        case 2:
            special_list[0] = &active9_10_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active11_12_instances;
            update_active_3(special_list, 1);
            special_list[0] = &active6_7_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active13_14_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active15_16_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active5_6_instances;
            update_active_3(special_list, 1);
            special_list[0] = &active3_4_instances;
            update_active_0(special_list, 1);
            special_list[0] = &camerachaser_46_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active4_5_instances;
            update_active_1(special_list, 1);
            special_list[0] = &active10_38_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active16_17_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active8_9_instances;
            update_active_3(special_list, 1);
            special_list[0] = &active2_2_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active7_8_instances;
            update_active_3(special_list, 1);
            special_list[0] = &active_1_instances;
            update_active_0(special_list, 1);
            break;
        case 4:
            special_list[0] = &active9_10_instances;
            update_active_1(special_list, 1);
            special_list[0] = &active11_12_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active6_7_instances;
            update_active_1(special_list, 1);
            special_list[0] = &active13_14_instances;
            update_active_3(special_list, 1);
            special_list[0] = &active5_6_instances;
            update_active_1(special_list, 1);
            special_list[0] = &active3_4_instances;
            update_active_1(special_list, 1);
            special_list[0] = &camerachaser_46_instances;
            update_active_1(special_list, 1);
            special_list[0] = &active4_5_instances;
            update_active_1(special_list, 1);
            special_list[0] = &active10_38_instances;
            update_active_1(special_list, 1);
            special_list[0] = &active8_9_instances;
            update_active_1(special_list, 1);
            special_list[0] = &active7_8_instances;
            update_active_1(special_list, 1);
            special_list[0] = &active_1_instances;
            update_active_1(special_list, 1);
            break;
        case 5:
            special_list[0] = &active3_4_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active4_5_instances;
            update_active_3(special_list, 1);
            special_list[0] = &active2_2_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active_1_instances;
            update_active_0(special_list, 1);
            break;
        case 6:
            special_list[0] = &active4_5_instances;
            update_active_0(special_list, 1);
            break;
        case 7:
            special_list[0] = &active3_4_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active4_5_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active2_2_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active_1_instances;
            update_active_0(special_list, 1);
            break;
        case 8:
            special_list[0] = &active5_6_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active3_4_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active4_5_instances;
            update_active_0(special_list, 1);
            special_list[0] = &active2_2_instances;
            update_active_3(special_list, 1);
            break;
    }
}
Frames::Frames()
: Frame()
{
    update_active_4_list[0] = &active3_27_instances;
    update_active_2_list[0] = &enemyhomingcog_261_instances;
    update_active_2_list[1] = &enemyblobululephase1_211_instances;
    update_active_2_list[2] = &homept2_206_instances;
    update_active_2_list[3] = &enemybrokenrobot_192_instances;
    update_active_2_list[4] = &enemygearoflaw_264_instances;
    update_active_2_list[5] = &enemydangerned_217_instances;
    update_active_2_list[6] = &homept1_205_instances;
    update_active_2_list[7] = &enemyhoppy_152_instances;
    update_active_2_list[8] = &enemypath_155_instances;
    update_active_2_list[9] = &enemyrockiship_227_instances;
    update_active_2_list[10] = &enemyfloater_165_instances;
    update_active_2_list[11] = &enemydroppo_222_instances;
    update_active_2_list[12] = &enemyflashbullet_168_instances;
    update_active_2_list[13] = &dropposhot_223_instances;
    update_active_2_list[14] = &spikeshooter_147_instances;
    update_active_2_list[15] = &enemylaser_202_instances;
    update_active_2_list[16] = &enemyboxman_262_instances;
    update_active_2_list[17] = &enemylonestarnew_278_instances;
    update_active_2_list[18] = &enemyblobululephase2_212_instances;
    update_active_2_list[19] = &active2_150_instances;
    update_active_3_list[0] = &uihelpbubble_276_instances;
    update_active_3_list[1] = &background_129_instances;
    update_active_3_list[2] = &afterimager_122_instances;
    update_active_3_list[3] = &fanblock_124_instances;
    update_active_3_list[4] = &debris_182_instances;
    update_active_3_list[5] = &afterimagel2_123_instances;
    update_active_3_list[6] = &spawnerjunkblock_282_instances;
    update_active_0_list[0] = &active12_13_instances;
    update_active_0_list[1] = &active18_19_instances;
    update_active_0_list[2] = &active31_86_instances;
    update_active_0_list[3] = &active23_72_instances;
    update_active_0_list[4] = &bganchor_289_instances;
    update_active_0_list[5] = &lginitpos_51_instances;
    update_active_0_list[6] = &healthbar_144_instances;
    update_active_0_list[7] = &uipowerupindicator_243_instances;
    update_active_0_list[8] = &camerashaker_247_instances;
    update_active_0_list[9] = &bgwheel_240_instances;
    update_active_0_list[10] = &active25_74_instances;
    update_active_0_list[11] = &active30_85_instances;
    update_active_0_list[12] = &devil_312_instances;
    update_active_0_list[13] = &kb_11_instances;
    update_active_0_list[14] = &active17_18_instances;
    update_active_0_list[15] = &active19_20_instances;
    update_active_0_list[16] = &active20_68_instances;
    update_active_0_list[17] = &spritewings_200_instances;
    update_active_0_list[18] = &inputcoordinatorsecretary_116_instances;
    update_active_0_list[19] = &camera_45_instances;
    update_active_0_list[20] = &cameratarget_248_instances;
    update_active_0_list[21] = &blockmaker_47_instances;
    update_active_0_list[22] = &healthbar2_186_instances;
    update_active_0_list[23] = &active32_88_instances;
    update_active_0_list[24] = &anchor_26_instances;
    update_active_0_list[25] = &graphicscreenshake_67_instances;
    update_active_0_list[26] = &musicsliderindicator_76_instances;
    update_active_0_list[27] = &healthbarbg_146_instances;
    update_active_0_list[28] = &roadmaker_48_instances;
    update_active_0_list[29] = &uilivesactive_259_instances;
    update_active_0_list[30] = &bgcog1_268_instances;
    update_active_0_list[31] = &active24_73_instances;
    update_active_0_list[32] = &musicslider_75_instances;
    update_active_0_list[33] = &active27_82_instances;
    update_active_0_list[34] = &caseanchor_288_instances;
    update_active_0_list[35] = &active29_84_instances;
    update_active_0_list[36] = &active14_15_instances;
    update_active_0_list[37] = &winscreenvars_285_instances;
    update_active_0_list[38] = &overlay2_22_instances;
    update_active_0_list[39] = &menudatastore_63_instances;
    update_active_0_list[40] = &active22_70_instances;
    update_active_0_list[41] = &uiflag_241_instances;
    update_active_0_list[42] = &framedatastore_183_instances;
    update_active_0_list[43] = &framevars_301_instances;
    update_active_0_list[44] = &active28_83_instances;
    update_active_0_list[45] = &notregular_90_instances;
    update_active_0_list[46] = &control_21_instances;
    update_active_0_list[47] = &active21_69_instances;
    update_active_0_list[48] = &active26_78_instances;
    update_active_0_list[49] = &graphicdashtype_64_instances;
    update_active_0_list[50] = &rando_41_instances;
    update_active_1_list[0] = &bulletpowerup_190_instances;
    update_active_1_list[1] = &enemychomper_184_instances;
    update_active_1_list[2] = &objkillplane_239_instances;
    update_active_1_list[3] = &platform2_98_instances;
    update_active_1_list[4] = &enemyboxspawner_263_instances;
    update_active_1_list[5] = &conveyorl_100_instances;
    update_active_1_list[6] = &objenemybounce_215_instances;
    update_active_1_list[7] = &enemyleft_161_instances;
    update_active_1_list[8] = &springleft_163_instances;
    update_active_1_list[9] = &objlasergunorange_256_instances;
    update_active_1_list[10] = &spikesleft_170_instances;
    update_active_1_list[11] = &horizspawner_209_instances;
    update_active_1_list[12] = &objfan_125_instances;
    update_active_1_list[13] = &enemyzappa_220_instances;
    update_active_1_list[14] = &spikeshooterspawner_149_instances;
    update_active_1_list[15] = &enemybrokenrobottop_194_instances;
    update_active_1_list[16] = &spawnerdropbro_281_instances;
    update_active_1_list[17] = &spawnerhoppy_151_instances;
    update_active_1_list[18] = &sendleft_158_instances;
    update_active_1_list[19] = &spawnerwalker_197_instances;
    update_active_1_list[20] = &ojbwings_199_instances;
    update_active_1_list[21] = &movingplatform_97_instances;
    update_active_1_list[22] = &spawnerevileye_245_instances;
    update_active_1_list[23] = &sprite_99_instances;
    update_active_1_list[24] = &bgcog2_269_instances;
    update_active_1_list[25] = &vertplatform_106_instances;
    update_active_1_list[26] = &camerabarriery_254_instances;
    update_active_1_list[27] = &spawnerbouncycog_271_instances;
    update_active_1_list[28] = &explosion_130_instances;
    update_active_1_list[29] = &objeyeblock_169_instances;
    update_active_1_list[30] = &hurter_132_instances;
    update_active_1_list[31] = &spikesbottom_171_instances;
    update_active_1_list[32] = &enemyexplosion_178_instances;
    update_active_1_list[33] = &detector_94_instances;
    update_active_1_list[34] = &spawnerrockitship_228_instances;
    update_active_1_list[35] = &senddown_157_instances;
    update_active_1_list[36] = &objshootspawner_232_instances;
    update_active_1_list[37] = &enemyspawnerhoppy_279_instances;
    update_active_1_list[38] = &enemyright_159_instances;
    update_active_1_list[39] = &enemyatom_176_instances;
    update_active_1_list[40] = &floaterspawner_166_instances;
    update_active_1_list[41] = &enemymobilebrohoriz_214_instances;
    update_active_1_list[42] = &screencamlayercamera_253_instances;
    update_active_1_list[43] = &vertdetector_107_instances;
    update_active_1_list[44] = &screenfar_277_instances;
    update_active_1_list[45] = &helpdesk_114_instances;
    update_active_1_list[46] = &tntstatic_131_instances;
    update_active_1_list[47] = &objnewcrate_274_instances;
    update_active_1_list[48] = &pipe_138_instances;
    update_active_1_list[49] = &bigexplosion_177_instances;
    update_active_1_list[50] = &objliftreverse_179_instances;
    update_active_1_list[51] = &spawnerscrewthrower_272_instances;
    update_active_1_list[52] = &player_93_instances;
    update_active_1_list[53] = &platform_95_instances;
    update_active_1_list[54] = &objectdashblockleft_188_instances;
    update_active_1_list[55] = &key_102_instances;
    update_active_1_list[56] = &spawnersnipereye_246_instances;
    update_active_1_list[57] = &spawnerlonestar_234_instances;
    update_active_1_list[58] = &objcratestopper_236_instances;
    update_active_1_list[59] = &objbonustime_258_instances;
    update_active_1_list[60] = &enemytoolio_260_instances;
    update_active_1_list[61] = &hurtbox_174_instances;
    update_active_1_list[62] = &enemygoo_213_instances;
    update_active_1_list[63] = &enemydown_160_instances;
    update_active_1_list[64] = &spikestop_172_instances;
    update_active_1_list[65] = &trapdoor_115_instances;
    update_active_1_list[66] = &boxdestroyer_137_instances;
    update_active_1_list[67] = &tntconveyor_139_instances;
    update_active_1_list[68] = &enemyzapball_185_instances;
    update_active_1_list[69] = &screen_148_instances;
    update_active_1_list[70] = &spawnerenemychomper_187_instances;
    update_active_1_list[71] = &objgarbagedestroyer_280_instances;
    update_active_1_list[72] = &conveyorr_101_instances;
    update_active_1_list[73] = &enemylonestar_233_instances;
    update_active_1_list[74] = &door_103_instances;
    update_active_1_list[75] = &enemywalker_196_instances;
    update_active_1_list[76] = &objenemygate_235_instances;
    update_active_1_list[77] = &objbonusdeathless_257_instances;
    update_active_1_list[78] = &vertspawner_210_instances;
    update_active_1_list[79] = &yonlyscroll_134_instances;
    update_active_1_list[80] = &spikesright_173_instances;
    update_active_1_list[81] = &objjunkblock_266_instances;
    update_active_1_list[82] = &spawneratom_175_instances;
    update_active_1_list[83] = &spawnerzappa_221_instances;
    update_active_1_list[84] = &bullet_121_instances;
    update_active_1_list[85] = &objcheckpointspawner_230_instances;
    update_active_1_list[86] = &spawnermobilebro_216_instances;
    update_active_1_list[87] = &sendup_154_instances;
    update_active_1_list[88] = &spawnerbrokenrobot_193_instances;
    update_active_1_list[89] = &sendright_156_instances;
    update_active_1_list[90] = &enemybrokenrobotbottom_195_instances;
    update_active_1_list[91] = &counterspawner_204_instances;
    update_active_1_list[92] = &xonlyscroll_133_instances;
    update_active_1_list[93] = &objcogblock_265_instances;
    update_active_1_list[94] = &lockxy_135_instances;
    update_active_1_list[95] = &spring_104_instances;
    update_active_1_list[96] = &detectorbelow_267_instances;
    update_active_1_list[97] = &screencamlayerlg_252_instances;
    update_active_1_list[98] = &enemyevileye_244_instances;
    update_active_1_list[99] = &objwatertop_128_instances;
    update_active_1_list[100] = &objcheckpoint_229_instances;
    update_active_1_list[101] = &objtntspawner_238_instances;
    update_active_1_list[102] = &dissappear_153_instances;
    update_active_1_list[103] = &enemyup_162_instances;
    update_active_1_list[104] = &objlasergun_201_instances;
    update_active_1_list[105] = &springright_164_instances;
    update_active_1_list[106] = &obscuretastictiles_117_instances;
    update_active_1_list[107] = &lgflattener_119_instances;
    update_active_1_list[108] = &camerabarrierx_251_instances;
    update_active_1_list[109] = &spawnerboxman_273_instances;
    update_active_1_list[110] = &objectdashblockright_189_instances;
    update_active_1_list[111] = &hoverer_136_instances;
    update_active_1_list[112] = &objectdashblockup_191_instances;
    update_active_1_list[113] = &roadlimit_50_instances;
}
void Frames::set_index(int index)
{
    static Frame1 frame1;
    static Frame2 frame2;
    static Frame3 frame3;
    static Frame4 frame4;
    static Frame5 frame5;
    static Frame6 frame6;
    static Frame7 frame7;
    static Frame8 frame8;
    static Frame9 frame9;
    switch (index) {
        case 0:
            data = &frame1;
            break;
        case 1:
            data = &frame2;
            break;
        case 2:
            data = &frame3;
            break;
        case 3:
            data = &frame4;
            break;
        case 4:
            data = &frame5;
            break;
        case 5:
            data = &frame6;
            break;
        case 6:
            data = &frame7;
            break;
        case 7:
            data = &frame8;
            break;
        case 8:
            data = &frame9;
            break;
        default:
            data = NULL;
            break;
    }
}
