#include "objects.h"
#include "common.h"
#include "fonts.h"
#include "font.h"
#include "lists.h"

class String7_0 : public Text
{
public:
    String7_0(int x, int y) : Text(x, y, String7_0_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("String 7", 8);
#endif
        flags &= ~SCROLL;
        width = 140;
        height = 13;
        blend_color = Color(255, 255, 255);
        bold = false;
        italic = false;
        font_name = chowstring("Small Fonts", 11);
        font = get_font(7, 0);
        alignment = ALIGN_LEFT | ALIGN_TOP;
        add_line(chowstring("Warning: this game is very difficult.", 37));
        create_alterables();
    }
};
FrameObject * create_string7_0(int x, int y)
{
    return new (Text::pool.create()) String7_0(x, y);
}
static Image* images_active_1_0_0[1];
static Direction direction_active_1_0_0 = {0, 50, 50, 0, 1, 1, images_active_1_0_0};
static Animation anim_active_1_0 = {&direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, NULL, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0, &direction_active_1_0_0};
static Animation * anim_array_active_1[1] = {&anim_active_1_0};
static Animations anim_active_1 = {1, &anim_array_active_1[0]};
static bool anim_active_1_initialized;
class Active_1 : public Active
{
public:
    Active_1(int x, int y) : Active(x, y, Active_1_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active", 6);
#endif
        this->animations = &anim_active_1;
        if (!anim_active_1_initialized) {
            anim_active_1_initialized = true;
            images_active_1_0_0[0] = get_internal_image_direct(1229);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active_1(int x, int y)
{
    return new (Active::pool.create()) Active_1(x, y);
}
static Image* images_active2_2_0_0[1];
static Direction direction_active2_2_0_0 = {0, 50, 50, 0, 1, 1, images_active2_2_0_0};
static Animation anim_active2_2_0 = {&direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, NULL, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0, &direction_active2_2_0_0};
static Animation * anim_array_active2_2[1] = {&anim_active2_2_0};
static Animations anim_active2_2 = {1, &anim_array_active2_2[0]};
static bool anim_active2_2_initialized;
class Active2_2 : public Active
{
public:
    Active2_2(int x, int y) : Active(x, y, Active2_2_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 2", 8);
#endif
        this->animations = &anim_active2_2;
        if (!anim_active2_2_initialized) {
            anim_active2_2_initialized = true;
            images_active2_2_0_0[0] = get_internal_image_direct(1228);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active2_2(int x, int y)
{
    return new (Active::pool.create()) Active2_2(x, y);
}
class String8_3 : public Text
{
public:
    String8_3(int x, int y) : Text(x, y, String8_3_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("String 8", 8);
#endif
        flags &= ~SCROLL;
        width = 140;
        height = 13;
        blend_color = Color(255, 255, 0);
        bold = false;
        italic = false;
        font_name = chowstring("Small Fonts", 11);
        font = get_font(7, 0);
        alignment = ALIGN_LEFT | ALIGN_TOP;
        add_line(chowstring("Pause", 5));
        create_alterables();
    }
};
FrameObject * create_string8_3(int x, int y)
{
    return new (Text::pool.create()) String8_3(x, y);
}
static Image* images_active3_4_0_0[1];
static Direction direction_active3_4_0_0 = {0, 50, 50, 0, 1, 1, images_active3_4_0_0};
static Animation anim_active3_4_0 = {&direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, NULL, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0, &direction_active3_4_0_0};
static Animation * anim_array_active3_4[1] = {&anim_active3_4_0};
static Animations anim_active3_4 = {1, &anim_array_active3_4[0]};
static bool anim_active3_4_initialized;
class Active3_4 : public Active
{
public:
    Active3_4(int x, int y) : Active(x, y, Active3_4_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 3", 8);
#endif
        this->animations = &anim_active3_4;
        if (!anim_active3_4_initialized) {
            anim_active3_4_initialized = true;
            images_active3_4_0_0[0] = get_internal_image_direct(1233);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active3_4(int x, int y)
{
    return new (Active::pool.create()) Active3_4(x, y);
}
static Image* images_active4_5_0_0[1];
static Direction direction_active4_5_0_0 = {0, 50, 50, 0, 1, 1, images_active4_5_0_0};
static Animation anim_active4_5_0 = {&direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, NULL, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0, &direction_active4_5_0_0};
static Animation * anim_array_active4_5[1] = {&anim_active4_5_0};
static Animations anim_active4_5 = {1, &anim_array_active4_5[0]};
static bool anim_active4_5_initialized;
class Active4_5 : public Active
{
public:
    Active4_5(int x, int y) : Active(x, y, Active4_5_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 4", 8);
#endif
        this->animations = &anim_active4_5;
        if (!anim_active4_5_initialized) {
            anim_active4_5_initialized = true;
            images_active4_5_0_0[0] = get_internal_image_direct(1234);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active4_5(int x, int y)
{
    return new (Active::pool.create()) Active4_5(x, y);
}
static Image* images_active5_6_0_0[1];
static Direction direction_active5_6_0_0 = {0, 50, 50, 0, 1, 1, images_active5_6_0_0};
static Animation anim_active5_6_0 = {&direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, NULL, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0, &direction_active5_6_0_0};
static Animation * anim_array_active5_6[1] = {&anim_active5_6_0};
static Animations anim_active5_6 = {1, &anim_array_active5_6[0]};
static bool anim_active5_6_initialized;
class Active5_6 : public Active
{
public:
    Active5_6(int x, int y) : Active(x, y, Active5_6_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 5", 8);
#endif
        this->animations = &anim_active5_6;
        if (!anim_active5_6_initialized) {
            anim_active5_6_initialized = true;
            images_active5_6_0_0[0] = get_internal_image_direct(1235);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active5_6(int x, int y)
{
    return new (Active::pool.create()) Active5_6(x, y);
}
static Image* images_active6_7_0_0[1];
static Direction direction_active6_7_0_0 = {0, 50, 50, 0, 1, 1, images_active6_7_0_0};
static Animation anim_active6_7_0 = {&direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, NULL, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0, &direction_active6_7_0_0};
static Animation * anim_array_active6_7[1] = {&anim_active6_7_0};
static Animations anim_active6_7 = {1, &anim_array_active6_7[0]};
static bool anim_active6_7_initialized;
class Active6_7 : public Active
{
public:
    Active6_7(int x, int y) : Active(x, y, Active6_7_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 6", 8);
#endif
        this->animations = &anim_active6_7;
        if (!anim_active6_7_initialized) {
            anim_active6_7_initialized = true;
            images_active6_7_0_0[0] = get_internal_image_direct(1231);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active6_7(int x, int y)
{
    return new (Active::pool.create()) Active6_7(x, y);
}
static Image* images_active7_8_0_0[1];
static Direction direction_active7_8_0_0 = {0, 50, 50, 0, 1, 1, images_active7_8_0_0};
static Animation anim_active7_8_0 = {&direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, NULL, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0, &direction_active7_8_0_0};
static Animation * anim_array_active7_8[1] = {&anim_active7_8_0};
static Animations anim_active7_8 = {1, &anim_array_active7_8[0]};
static bool anim_active7_8_initialized;
class Active7_8 : public Active
{
public:
    Active7_8(int x, int y) : Active(x, y, Active7_8_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 7", 8);
#endif
        this->animations = &anim_active7_8;
        if (!anim_active7_8_initialized) {
            anim_active7_8_initialized = true;
            images_active7_8_0_0[0] = get_internal_image_direct(1236);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active7_8(int x, int y)
{
    return new (Active::pool.create()) Active7_8(x, y);
}
static Image* images_active8_9_0_0[1];
static Direction direction_active8_9_0_0 = {0, 50, 50, 0, 1, 1, images_active8_9_0_0};
static Animation anim_active8_9_0 = {&direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, NULL, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0, &direction_active8_9_0_0};
static Animation * anim_array_active8_9[1] = {&anim_active8_9_0};
static Animations anim_active8_9 = {1, &anim_array_active8_9[0]};
static bool anim_active8_9_initialized;
class Active8_9 : public Active
{
public:
    Active8_9(int x, int y) : Active(x, y, Active8_9_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 8", 8);
#endif
        this->animations = &anim_active8_9;
        if (!anim_active8_9_initialized) {
            anim_active8_9_initialized = true;
            images_active8_9_0_0[0] = get_internal_image_direct(1237);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active8_9(int x, int y)
{
    return new (Active::pool.create()) Active8_9(x, y);
}
static Image* images_active9_10_0_0[1];
static Direction direction_active9_10_0_0 = {0, 50, 50, 0, 1, 1, images_active9_10_0_0};
static Animation anim_active9_10_0 = {&direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, NULL, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0, &direction_active9_10_0_0};
static Animation * anim_array_active9_10[1] = {&anim_active9_10_0};
static Animations anim_active9_10 = {1, &anim_array_active9_10[0]};
static bool anim_active9_10_initialized;
class Active9_10 : public Active
{
public:
    Active9_10(int x, int y) : Active(x, y, Active9_10_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 9", 8);
#endif
        this->animations = &anim_active9_10;
        if (!anim_active9_10_initialized) {
            anim_active9_10_initialized = true;
            images_active9_10_0_0[0] = get_internal_image_direct(1230);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active9_10(int x, int y)
{
    return new (Active::pool.create()) Active9_10(x, y);
}
static Image* images_kb_11_0_0[2];
static Direction direction_kb_11_0_0 = {0, 3, 3, 0, -1, 2, images_kb_11_0_0};
static Animation anim_kb_11_0 = {&direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, NULL, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0, &direction_kb_11_0_0};
static Animation * anim_array_kb_11[1] = {&anim_kb_11_0};
static Animations anim_kb_11 = {1, &anim_array_kb_11[0]};
static bool anim_kb_11_initialized;
class Kb_11 : public Active
{
public:
    Kb_11(int x, int y) : Active(x, y, Kb_11_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("kb", 2);
#endif
        this->animations = &anim_kb_11;
        if (!anim_kb_11_initialized) {
            anim_kb_11_initialized = true;
            images_kb_11_0_0[0] = get_internal_image_direct(1247);
            images_kb_11_0_0[1] = get_internal_image_direct(1245);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_kb_11(int x, int y)
{
    return new (Active::pool.create()) Kb_11(x, y);
}
static Image* images_active11_12_0_0[1];
static Direction direction_active11_12_0_0 = {0, 50, 50, 0, 1, 1, images_active11_12_0_0};
static Animation anim_active11_12_0 = {&direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, NULL, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0, &direction_active11_12_0_0};
static Animation * anim_array_active11_12[1] = {&anim_active11_12_0};
static Animations anim_active11_12 = {1, &anim_array_active11_12[0]};
static bool anim_active11_12_initialized;
class Active11_12 : public Active
{
public:
    Active11_12(int x, int y) : Active(x, y, Active11_12_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 11", 9);
#endif
        this->animations = &anim_active11_12;
        if (!anim_active11_12_initialized) {
            anim_active11_12_initialized = true;
            images_active11_12_0_0[0] = get_internal_image_direct(1243);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active11_12(int x, int y)
{
    return new (Active::pool.create()) Active11_12(x, y);
}
static Image* images_active12_13_0_0[1];
static Direction direction_active12_13_0_0 = {0, 50, 50, 0, 1, 1, images_active12_13_0_0};
static Animation anim_active12_13_0 = {&direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, NULL, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0, &direction_active12_13_0_0};
static Animation * anim_array_active12_13[1] = {&anim_active12_13_0};
static Animations anim_active12_13 = {1, &anim_array_active12_13[0]};
static bool anim_active12_13_initialized;
class Active12_13 : public Active
{
public:
    Active12_13(int x, int y) : Active(x, y, Active12_13_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 12", 9);
#endif
        this->animations = &anim_active12_13;
        if (!anim_active12_13_initialized) {
            anim_active12_13_initialized = true;
            images_active12_13_0_0[0] = get_internal_image_direct(1239);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active12_13(int x, int y)
{
    return new (Active::pool.create()) Active12_13(x, y);
}
static Image* images_active13_14_0_0[1];
static Direction direction_active13_14_0_0 = {0, 50, 50, 0, 1, 1, images_active13_14_0_0};
static Animation anim_active13_14_0 = {&direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, NULL, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0, &direction_active13_14_0_0};
static Animation * anim_array_active13_14[1] = {&anim_active13_14_0};
static Animations anim_active13_14 = {1, &anim_array_active13_14[0]};
static bool anim_active13_14_initialized;
class Active13_14 : public Active
{
public:
    Active13_14(int x, int y) : Active(x, y, Active13_14_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 13", 9);
#endif
        this->animations = &anim_active13_14;
        if (!anim_active13_14_initialized) {
            anim_active13_14_initialized = true;
            images_active13_14_0_0[0] = get_internal_image_direct(1241);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active13_14(int x, int y)
{
    return new (Active::pool.create()) Active13_14(x, y);
}
static Image* images_active14_15_0_0[1];
static Direction direction_active14_15_0_0 = {0, 50, 50, 0, 1, 1, images_active14_15_0_0};
static Animation anim_active14_15_0 = {&direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, NULL, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0, &direction_active14_15_0_0};
static Animation * anim_array_active14_15[1] = {&anim_active14_15_0};
static Animations anim_active14_15 = {1, &anim_array_active14_15[0]};
static bool anim_active14_15_initialized;
class Active14_15 : public Active
{
public:
    Active14_15(int x, int y) : Active(x, y, Active14_15_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 14", 9);
#endif
        this->animations = &anim_active14_15;
        if (!anim_active14_15_initialized) {
            anim_active14_15_initialized = true;
            images_active14_15_0_0[0] = get_internal_image_direct(1242);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active14_15(int x, int y)
{
    return new (Active::pool.create()) Active14_15(x, y);
}
static Image* images_active15_16_0_0[1];
static Direction direction_active15_16_0_0 = {0, 50, 50, 0, 1, 1, images_active15_16_0_0};
static Animation anim_active15_16_0 = {&direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, NULL, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0, &direction_active15_16_0_0};
static Animation * anim_array_active15_16[1] = {&anim_active15_16_0};
static Animations anim_active15_16 = {1, &anim_array_active15_16[0]};
static bool anim_active15_16_initialized;
class Active15_16 : public Active
{
public:
    Active15_16(int x, int y) : Active(x, y, Active15_16_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 15", 9);
#endif
        this->animations = &anim_active15_16;
        if (!anim_active15_16_initialized) {
            anim_active15_16_initialized = true;
            images_active15_16_0_0[0] = get_internal_image_direct(1232);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active15_16(int x, int y)
{
    return new (Active::pool.create()) Active15_16(x, y);
}
static Image* images_active16_17_0_0[1];
static Direction direction_active16_17_0_0 = {0, 50, 50, 0, 1, 1, images_active16_17_0_0};
static Animation anim_active16_17_0 = {&direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, NULL, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0, &direction_active16_17_0_0};
static Animation * anim_array_active16_17[1] = {&anim_active16_17_0};
static Animations anim_active16_17 = {1, &anim_array_active16_17[0]};
static bool anim_active16_17_initialized;
class Active16_17 : public Active
{
public:
    Active16_17(int x, int y) : Active(x, y, Active16_17_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 16", 9);
#endif
        this->animations = &anim_active16_17;
        if (!anim_active16_17_initialized) {
            anim_active16_17_initialized = true;
            images_active16_17_0_0[0] = get_internal_image_direct(1231);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active16_17(int x, int y)
{
    return new (Active::pool.create()) Active16_17(x, y);
}
static Image* images_active17_18_0_0[1];
static Direction direction_active17_18_0_0 = {0, 50, 50, 0, 1, 1, images_active17_18_0_0};
static Animation anim_active17_18_0 = {&direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, NULL, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0, &direction_active17_18_0_0};
static Animation * anim_array_active17_18[1] = {&anim_active17_18_0};
static Animations anim_active17_18 = {1, &anim_array_active17_18[0]};
static bool anim_active17_18_initialized;
class Active17_18 : public Active
{
public:
    Active17_18(int x, int y) : Active(x, y, Active17_18_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 17", 9);
#endif
        this->animations = &anim_active17_18;
        if (!anim_active17_18_initialized) {
            anim_active17_18_initialized = true;
            images_active17_18_0_0[0] = get_internal_image_direct(1238);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active17_18(int x, int y)
{
    return new (Active::pool.create()) Active17_18(x, y);
}
static Image* images_active18_19_0_0[1];
static Direction direction_active18_19_0_0 = {0, 50, 50, 0, 1, 1, images_active18_19_0_0};
static Animation anim_active18_19_0 = {&direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, NULL, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0, &direction_active18_19_0_0};
static Animation * anim_array_active18_19[1] = {&anim_active18_19_0};
static Animations anim_active18_19 = {1, &anim_array_active18_19[0]};
static bool anim_active18_19_initialized;
class Active18_19 : public Active
{
public:
    Active18_19(int x, int y) : Active(x, y, Active18_19_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 18", 9);
#endif
        this->animations = &anim_active18_19;
        if (!anim_active18_19_initialized) {
            anim_active18_19_initialized = true;
            images_active18_19_0_0[0] = get_internal_image_direct(1240);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active18_19(int x, int y)
{
    return new (Active::pool.create()) Active18_19(x, y);
}
static Image* images_active19_20_0_0[1];
static Direction direction_active19_20_0_0 = {0, 50, 50, 0, 1, 1, images_active19_20_0_0};
static Animation anim_active19_20_0 = {&direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, NULL, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0, &direction_active19_20_0_0};
static Animation * anim_array_active19_20[1] = {&anim_active19_20_0};
static Animations anim_active19_20 = {1, &anim_array_active19_20[0]};
static bool anim_active19_20_initialized;
class Active19_20 : public Active
{
public:
    Active19_20(int x, int y) : Active(x, y, Active19_20_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 19", 9);
#endif
        this->animations = &anim_active19_20;
        if (!anim_active19_20_initialized) {
            anim_active19_20_initialized = true;
            images_active19_20_0_0[0] = get_internal_image_direct(1244);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active19_20(int x, int y)
{
    return new (Active::pool.create()) Active19_20(x, y);
}
static Image* images_control_21_0_0[2];
static Direction direction_control_21_0_0 = {0, 3, 3, 0, -1, 2, images_control_21_0_0};
static Animation anim_control_21_0 = {&direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, NULL, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0, &direction_control_21_0_0};
static Animation * anim_array_control_21[1] = {&anim_control_21_0};
static Animations anim_control_21 = {1, &anim_array_control_21[0]};
static bool anim_control_21_initialized;
class Control_21 : public Active
{
public:
    Control_21(int x, int y) : Active(x, y, Control_21_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("control", 7);
#endif
        this->animations = &anim_control_21;
        if (!anim_control_21_initialized) {
            anim_control_21_initialized = true;
            images_control_21_0_0[0] = get_internal_image_direct(3);
            images_control_21_0_0[1] = get_internal_image_direct(1246);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
        alterables->values.set(0, 640);
    }
};
FrameObject * create_control_21(int x, int y)
{
    return new (Active::pool.create()) Control_21(x, y);
}
static Image* images_overlay2_22_0_0[1];
static Direction direction_overlay2_22_0_0 = {0, 50, 50, 0, -1, 1, images_overlay2_22_0_0};
static Animation anim_overlay2_22_0 = {&direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, NULL, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0, &direction_overlay2_22_0_0};
static Image* images_overlay2_22_12_0[1];
static Direction direction_overlay2_22_12_0 = {0, 50, 50, 0, -1, 1, images_overlay2_22_12_0};
static Animation anim_overlay2_22_12 = {&direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, NULL, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0, &direction_overlay2_22_12_0};
static Animation * anim_array_overlay2_22[13] = {&anim_overlay2_22_0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, &anim_overlay2_22_12};
static Animations anim_overlay2_22 = {13, &anim_array_overlay2_22[0]};
static bool anim_overlay2_22_initialized;
class Overlay2_22 : public Active
{
public:
    Overlay2_22(int x, int y) : Active(x, y, Overlay2_22_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Overlay 2", 9);
#endif
        this->animations = &anim_overlay2_22;
        if (!anim_overlay2_22_initialized) {
            anim_overlay2_22_initialized = true;
            images_overlay2_22_0_0[0] = get_internal_image_direct(1026);
            images_overlay2_22_12_0[0] = get_internal_image_direct(1027);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_overlay2_22(int x, int y)
{
    return new (Active::pool.create()) Overlay2_22(x, y);
}
static Image* images_active_23_0_0[1];
static Direction direction_active_23_0_0 = {0, 50, 50, 0, 1, 1, images_active_23_0_0};
static Animation anim_active_23_0 = {&direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, NULL, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0, &direction_active_23_0_0};
static Animation * anim_array_active_23[1] = {&anim_active_23_0};
static Animations anim_active_23 = {1, &anim_array_active_23[0]};
static bool anim_active_23_initialized;
class Active_23 : public Active
{
public:
    Active_23(int x, int y) : Active(x, y, Active_23_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active", 6);
#endif
        this->animations = &anim_active_23;
        if (!anim_active_23_initialized) {
            anim_active_23_initialized = true;
            images_active_23_0_0[0] = get_internal_image_direct(383);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active_23(int x, int y)
{
    return new (Active::pool.create()) Active_23(x, y);
}
static Image* images_active6_24_0_0[1];
static Direction direction_active6_24_0_0 = {0, 50, 50, 0, 1, 1, images_active6_24_0_0};
static Animation anim_active6_24_0 = {&direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, NULL, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0, &direction_active6_24_0_0};
static Animation * anim_array_active6_24[1] = {&anim_active6_24_0};
static Animations anim_active6_24 = {1, &anim_array_active6_24[0]};
static bool anim_active6_24_initialized;
class Active6_24 : public Active
{
public:
    Active6_24(int x, int y) : Active(x, y, Active6_24_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 6", 8);
#endif
        this->animations = &anim_active6_24;
        if (!anim_active6_24_initialized) {
            anim_active6_24_initialized = true;
            images_active6_24_0_0[0] = get_internal_image_direct(493);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active6_24(int x, int y)
{
    return new (Active::pool.create()) Active6_24(x, y);
}
static Image* images_active2_25_0_0[1];
static Direction direction_active2_25_0_0 = {0, 50, 50, 0, 1, 1, images_active2_25_0_0};
static Animation anim_active2_25_0 = {&direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, NULL, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0, &direction_active2_25_0_0};
static Animation * anim_array_active2_25[1] = {&anim_active2_25_0};
static Animations anim_active2_25 = {1, &anim_array_active2_25[0]};
static bool anim_active2_25_initialized;
class Active2_25 : public Active
{
public:
    Active2_25(int x, int y) : Active(x, y, Active2_25_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 2", 8);
#endif
        this->animations = &anim_active2_25;
        if (!anim_active2_25_initialized) {
            anim_active2_25_initialized = true;
            images_active2_25_0_0[0] = get_internal_image_direct(538);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active2_25(int x, int y)
{
    return new (Active::pool.create()) Active2_25(x, y);
}
static Image* images_anchor_26_0_0[1];
static Direction direction_anchor_26_0_0 = {0, 50, 50, 0, 1, 1, images_anchor_26_0_0};
static Animation anim_anchor_26_0 = {&direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, NULL, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0, &direction_anchor_26_0_0};
static Animation * anim_array_anchor_26[1] = {&anim_anchor_26_0};
static Animations anim_anchor_26 = {1, &anim_array_anchor_26[0]};
static bool anim_anchor_26_initialized;
class Anchor_26 : public Active
{
public:
    Anchor_26(int x, int y) : Active(x, y, Anchor_26_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("anchor", 6);
#endif
        set_visible(false);
        this->animations = &anim_anchor_26;
        if (!anim_anchor_26_initialized) {
            anim_anchor_26_initialized = true;
            images_anchor_26_0_0[0] = get_internal_image_direct(7);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_anchor_26(int x, int y)
{
    return new (Active::pool.create()) Anchor_26(x, y);
}
static Image* images_active3_27_0_0[1];
static Direction direction_active3_27_0_0 = {0, 50, 50, 0, 1, 1, images_active3_27_0_0};
static Animation anim_active3_27_0 = {&direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, NULL, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0, &direction_active3_27_0_0};
static Animation * anim_array_active3_27[1] = {&anim_active3_27_0};
static Animations anim_active3_27 = {1, &anim_array_active3_27[0]};
static bool anim_active3_27_initialized;
class Active3_27 : public Active
{
public:
    Active3_27(int x, int y) : Active(x, y, Active3_27_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 3", 8);
#endif
        this->animations = &anim_active3_27;
        if (!anim_active3_27_initialized) {
            anim_active3_27_initialized = true;
            images_active3_27_0_0[0] = get_internal_image_direct(551);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        set_direction(0);
        movement = new BallMovement(this);
        movement->index = 0;
        movement->flags |= Movement::MOVE_AT_START;
        ((BallMovement*)movement)->set_max_speed(0);
        ((BallMovement*)movement)->set_deceleration(0);
        ((BallMovement*)movement)->randomizer = 20;
        ((BallMovement*)movement)->init();
        create_alterables();
    }
};
FrameObject * create_active3_27(int x, int y)
{
    return new (Active::pool.create()) Active3_27(x, y);
}
static Image* images_active4_28_0_0[1];
static Direction direction_active4_28_0_0 = {0, 50, 50, 0, 1, 1, images_active4_28_0_0};
static Animation anim_active4_28_0 = {&direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, NULL, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0, &direction_active4_28_0_0};
static Animation * anim_array_active4_28[1] = {&anim_active4_28_0};
static Animations anim_active4_28 = {1, &anim_array_active4_28[0]};
static bool anim_active4_28_initialized;
class Active4_28 : public Active
{
public:
    Active4_28(int x, int y) : Active(x, y, Active4_28_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 4", 8);
#endif
        set_visible(false);
        this->animations = &anim_active4_28;
        if (!anim_active4_28_initialized) {
            anim_active4_28_initialized = true;
            images_active4_28_0_0[0] = get_internal_image_direct(554);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active4_28(int x, int y)
{
    return new (Active::pool.create()) Active4_28(x, y);
}
class Backdrop_29 : public Backdrop
{
public:
    Backdrop_29(int x, int y) : Backdrop(x, y, BACKGROUND_TYPE)
    {
#ifndef NDEBUG
        name = chowstring("Backdrop", 8);
#endif
        flags |= BACKGROUND;
        flags |= BACKGROUND_COL;
#ifdef BACK_ID_BACKDROP
        manager.frame->back_instances[BACK_ID_BACKDROP].push_back(this);
#endif
        image = get_internal_image(385);
        width = image->width;
        height = image->height;
    }
};
FrameObject * create_backdrop_29(int x, int y)
{
    return new (Backdrop::pool.create()) Backdrop_29(x, y);
}
static Image* images_active_30_0_0[1];
static Direction direction_active_30_0_0 = {0, 50, 50, 0, 1, 1, images_active_30_0_0};
static Animation anim_active_30_0 = {&direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, NULL, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0, &direction_active_30_0_0};
static Animation * anim_array_active_30[1] = {&anim_active_30_0};
static Animations anim_active_30 = {1, &anim_array_active_30[0]};
static bool anim_active_30_initialized;
class Active_30 : public Active
{
public:
    Active_30(int x, int y) : Active(x, y, Active_30_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active", 6);
#endif
        this->animations = &anim_active_30;
        if (!anim_active_30_initialized) {
            anim_active_30_initialized = true;
            images_active_30_0_0[0] = get_internal_image_direct(426);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        blend_color = Color(255, 255, 255, 44);
        create_alterables();
    }
};
FrameObject * create_active_30(int x, int y)
{
    return new (Active::pool.create()) Active_30(x, y);
}
static Image* images_active2_31_0_0[1];
static Direction direction_active2_31_0_0 = {0, 50, 50, 0, 1, 1, images_active2_31_0_0};
static Animation anim_active2_31_0 = {&direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, NULL, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0, &direction_active2_31_0_0};
static Animation * anim_array_active2_31[1] = {&anim_active2_31_0};
static Animations anim_active2_31 = {1, &anim_array_active2_31[0]};
static bool anim_active2_31_initialized;
class Active2_31 : public Active
{
public:
    Active2_31(int x, int y) : Active(x, y, Active2_31_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 2", 8);
#endif
        this->animations = &anim_active2_31;
        if (!anim_active2_31_initialized) {
            anim_active2_31_initialized = true;
            images_active2_31_0_0[0] = get_internal_image_direct(412);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active2_31(int x, int y)
{
    return new (Active::pool.create()) Active2_31(x, y);
}
static Image* images_active3_32_0_0[1];
static Direction direction_active3_32_0_0 = {0, 50, 50, 0, 1, 1, images_active3_32_0_0};
static Animation anim_active3_32_0 = {&direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, NULL, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0, &direction_active3_32_0_0};
static Animation * anim_array_active3_32[1] = {&anim_active3_32_0};
static Animations anim_active3_32 = {1, &anim_array_active3_32[0]};
static bool anim_active3_32_initialized;
class Active3_32 : public Active
{
public:
    Active3_32(int x, int y) : Active(x, y, Active3_32_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 3", 8);
#endif
        this->animations = &anim_active3_32;
        if (!anim_active3_32_initialized) {
            anim_active3_32_initialized = true;
            images_active3_32_0_0[0] = get_internal_image_direct(461);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active3_32(int x, int y)
{
    return new (Active::pool.create()) Active3_32(x, y);
}
static Image* images_active4_33_0_0[1];
static Direction direction_active4_33_0_0 = {0, 50, 50, 0, 1, 1, images_active4_33_0_0};
static Animation anim_active4_33_0 = {&direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, NULL, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0, &direction_active4_33_0_0};
static Animation * anim_array_active4_33[1] = {&anim_active4_33_0};
static Animations anim_active4_33 = {1, &anim_array_active4_33[0]};
static bool anim_active4_33_initialized;
class Active4_33 : public Active
{
public:
    Active4_33(int x, int y) : Active(x, y, Active4_33_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 4", 8);
#endif
        flags &= ~SCROLL;
        this->animations = &anim_active4_33;
        if (!anim_active4_33_initialized) {
            anim_active4_33_initialized = true;
            images_active4_33_0_0[0] = get_internal_image_direct(427);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active4_33(int x, int y)
{
    return new (Active::pool.create()) Active4_33(x, y);
}
static Image* images_active5_34_0_0[1];
static Direction direction_active5_34_0_0 = {0, 50, 50, 0, 1, 1, images_active5_34_0_0};
static Animation anim_active5_34_0 = {&direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, NULL, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0, &direction_active5_34_0_0};
static Animation * anim_array_active5_34[1] = {&anim_active5_34_0};
static Animations anim_active5_34 = {1, &anim_array_active5_34[0]};
static bool anim_active5_34_initialized;
class Active5_34 : public Active
{
public:
    Active5_34(int x, int y) : Active(x, y, Active5_34_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 5", 8);
#endif
        this->animations = &anim_active5_34;
        if (!anim_active5_34_initialized) {
            anim_active5_34_initialized = true;
            images_active5_34_0_0[0] = get_internal_image_direct(460);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active5_34(int x, int y)
{
    return new (Active::pool.create()) Active5_34(x, y);
}
static Image* images_active7_35_0_0[1];
static Direction direction_active7_35_0_0 = {0, 50, 50, 0, 1, 1, images_active7_35_0_0};
static Animation anim_active7_35_0 = {&direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, NULL, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0, &direction_active7_35_0_0};
static Animation * anim_array_active7_35[1] = {&anim_active7_35_0};
static Animations anim_active7_35 = {1, &anim_array_active7_35[0]};
static bool anim_active7_35_initialized;
class Active7_35 : public Active
{
public:
    Active7_35(int x, int y) : Active(x, y, Active7_35_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 7", 8);
#endif
        this->animations = &anim_active7_35;
        if (!anim_active7_35_initialized) {
            anim_active7_35_initialized = true;
            images_active7_35_0_0[0] = get_internal_image_direct(471);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active7_35(int x, int y)
{
    return new (Active::pool.create()) Active7_35(x, y);
}
static Image* images_active8_36_0_0[1];
static Direction direction_active8_36_0_0 = {0, 50, 50, 0, 1, 1, images_active8_36_0_0};
static Animation anim_active8_36_0 = {&direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, NULL, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0, &direction_active8_36_0_0};
static Animation * anim_array_active8_36[1] = {&anim_active8_36_0};
static Animations anim_active8_36 = {1, &anim_array_active8_36[0]};
static bool anim_active8_36_initialized;
class Active8_36 : public Active
{
public:
    Active8_36(int x, int y) : Active(x, y, Active8_36_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 8", 8);
#endif
        this->animations = &anim_active8_36;
        if (!anim_active8_36_initialized) {
            anim_active8_36_initialized = true;
            images_active8_36_0_0[0] = get_internal_image_direct(472);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active8_36(int x, int y)
{
    return new (Active::pool.create()) Active8_36(x, y);
}
static Image* images_active9_37_0_0[2];
static Direction direction_active9_37_0_0 = {0, 50, 50, 0, -1, 2, images_active9_37_0_0};
static Animation anim_active9_37_0 = {&direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, NULL, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0, &direction_active9_37_0_0};
static Animation * anim_array_active9_37[1] = {&anim_active9_37_0};
static Animations anim_active9_37 = {1, &anim_array_active9_37[0]};
static bool anim_active9_37_initialized;
class Active9_37 : public Active
{
public:
    Active9_37(int x, int y) : Active(x, y, Active9_37_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 9", 8);
#endif
        this->animations = &anim_active9_37;
        if (!anim_active9_37_initialized) {
            anim_active9_37_initialized = true;
            images_active9_37_0_0[0] = get_internal_image_direct(778);
            images_active9_37_0_0[1] = get_internal_image_direct(779);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
        alterables->values.set(1, 110);
        alterables->values.set(2, 260);
        alterables->values.set(3, 80);
    }
};
FrameObject * create_active9_37(int x, int y)
{
    return new (Active::pool.create()) Active9_37(x, y);
}
static Image* images_active10_38_0_0[2];
static Direction direction_active10_38_0_0 = {0, 50, 50, 0, -1, 2, images_active10_38_0_0};
static Animation anim_active10_38_0 = {&direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, NULL, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0, &direction_active10_38_0_0};
static Animation * anim_array_active10_38[1] = {&anim_active10_38_0};
static Animations anim_active10_38 = {1, &anim_array_active10_38[0]};
static bool anim_active10_38_initialized;
class Active10_38 : public Active
{
public:
    Active10_38(int x, int y) : Active(x, y, Active10_38_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 10", 9);
#endif
        this->animations = &anim_active10_38;
        if (!anim_active10_38_initialized) {
            anim_active10_38_initialized = true;
            images_active10_38_0_0[0] = get_internal_image_direct(478);
            images_active10_38_0_0[1] = get_internal_image_direct(477);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        blend_color = Color(255, 255, 255, 51);
        create_alterables();
    }
};
FrameObject * create_active10_38(int x, int y)
{
    return new (Active::pool.create()) Active10_38(x, y);
}
class QuickBackdrop_39 : public QuickBackdrop
{
public:
    QuickBackdrop_39(int x, int y) : QuickBackdrop(x, y, BACKGROUND_TYPE)
    {
#ifndef NDEBUG
        name = chowstring("Quick Backdrop", 14);
#endif
        flags |= BACKGROUND;
        flags |= BACKGROUND_COL;
        width = 640;
        height = 168;
        color = Color(0, 0, 0);
        gradient_type = NONE_GRADIENT;
        outline = 0;
    }
};
FrameObject * create_quickbackdrop_39(int x, int y)
{
    return new (QuickBackdrop::pool.create()) QuickBackdrop_39(x, y);
}
static Image* images_active11_40_0_0[1];
static Direction direction_active11_40_0_0 = {0, 50, 50, 0, 1, 1, images_active11_40_0_0};
static Animation anim_active11_40_0 = {&direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, NULL, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0, &direction_active11_40_0_0};
static Animation * anim_array_active11_40[1] = {&anim_active11_40_0};
static Animations anim_active11_40 = {1, &anim_array_active11_40[0]};
static bool anim_active11_40_initialized;
class Active11_40 : public Active
{
public:
    Active11_40(int x, int y) : Active(x, y, Active11_40_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 11", 9);
#endif
        this->animations = &anim_active11_40;
        if (!anim_active11_40_initialized) {
            anim_active11_40_initialized = true;
            images_active11_40_0_0[0] = get_internal_image_direct(480);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active11_40(int x, int y)
{
    return new (Active::pool.create()) Active11_40(x, y);
}
static Image* images_rando_41_0_0[1];
static Direction direction_rando_41_0_0 = {0, 50, 50, 0, 1, 1, images_rando_41_0_0};
static Animation anim_rando_41_0 = {&direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, NULL, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0, &direction_rando_41_0_0};
static Animation * anim_array_rando_41[1] = {&anim_rando_41_0};
static Animations anim_rando_41 = {1, &anim_array_rando_41[0]};
static bool anim_rando_41_initialized;
class Rando_41 : public Active
{
public:
    Rando_41(int x, int y) : Active(x, y, Rando_41_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("rando", 5);
#endif
        this->animations = &anim_rando_41;
        if (!anim_rando_41_initialized) {
            anim_rando_41_initialized = true;
            images_rando_41_0_0[0] = get_internal_image_direct(7);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_rando_41(int x, int y)
{
    return new (Active::pool.create()) Rando_41(x, y);
}
static Image* images_active13_42_0_0[2];
static Direction direction_active13_42_0_0 = {0, 0, 0, 0, 1, 2, images_active13_42_0_0};
static Animation anim_active13_42_0 = {&direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, NULL, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0, &direction_active13_42_0_0};
static Image* images_active13_42_1_0[1];
static Direction direction_active13_42_1_0 = {0, 50, 50, 0, 1, 1, images_active13_42_1_0};
static Animation anim_active13_42_1 = {&direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, NULL, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0, &direction_active13_42_1_0};
static Image* images_active13_42_2_0[1];
static Direction direction_active13_42_2_0 = {0, 50, 50, 0, -1, 1, images_active13_42_2_0};
static Animation anim_active13_42_2 = {&direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, NULL, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0, &direction_active13_42_2_0};
static Image* images_active13_42_3_0[1];
static Direction direction_active13_42_3_0 = {0, 50, 50, 0, 1, 1, images_active13_42_3_0};
static Animation anim_active13_42_3 = {&direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, NULL, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0, &direction_active13_42_3_0};
static Image* images_active13_42_5_0[1];
static Direction direction_active13_42_5_0 = {0, 50, 50, 0, -1, 1, images_active13_42_5_0};
static Animation anim_active13_42_5 = {&direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, NULL, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0, &direction_active13_42_5_0};
static Animation * anim_array_active13_42[6] = {&anim_active13_42_0, &anim_active13_42_1, &anim_active13_42_2, &anim_active13_42_3, NULL, &anim_active13_42_5};
static Animations anim_active13_42 = {6, &anim_array_active13_42[0]};
static bool anim_active13_42_initialized;
class Active13_42 : public Active
{
public:
    Active13_42(int x, int y) : Active(x, y, Active13_42_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 13", 9);
#endif
        set_visible(false);
        this->animations = &anim_active13_42;
        if (!anim_active13_42_initialized) {
            anim_active13_42_initialized = true;
            images_active13_42_0_0[0] = get_internal_image_direct(31);
            images_active13_42_0_0[1] = get_internal_image_direct(475);
            images_active13_42_1_0[0] = get_internal_image_direct(486);
            images_active13_42_2_0[0] = get_internal_image_direct(777);
            images_active13_42_3_0[0] = get_internal_image_direct(475);
            images_active13_42_5_0[0] = get_internal_image_direct(704);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        forced_animation = current_animation = APPEARING;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active13_42(int x, int y)
{
    return new (Active::pool.create()) Active13_42(x, y);
}
class String2_43 : public Text
{
public:
    String2_43(int x, int y) : Text(x, y, String2_43_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("String 2", 8);
#endif
        flags &= ~SCROLL;
        width = 640;
        height = 168;
        blend_color = Color(255, 255, 255);
        bold = false;
        italic = false;
        font_name = chowstring("Small Fonts", 11);
        font = get_font(7, 0);
        alignment = ALIGN_HCENTER | ALIGN_VCENTER;
        add_line(chowstring("CREATED AND DEVELOPED BY\r\nRob Welch", 35));
        add_line(chowstring("FEATURING THE MOTION CAPTURED PERFORMANCE OF\r\nTom Hanks", 55));
        add_line(chowstring("BASED ON A NAPKIN DOODLE BY\r\nMatt Dodds", 39));
        add_line(chowstring("LAWYER GUY'S SENIOR COOL PLAYTESTERS\r\nZmansjams\\Smajsnamz\r\nJon Dong Williams\r\nSpecs\r\nSoup and Sauce\r\nMoogs Moogerson", 116));
        add_line(chowstring("LAWYER GUY'S COOL PLAYTESTERS\r\nLames\r\nZachary Richardson\r\nLou\r\nAniMitch\r\nNabil\r\nLiam Tilling\r\nSef The One Who Hates This Kind Of Game\r\nRd\r\nM. Algora", 148));
        add_line(chowstring("SPECIAL THANKS\r\nSebastian Janisz\r\nAlbin Hanberg\r\nMathias K\303\246rlev\r\nThe guy at the Florrigardy Hotel in Skye who mailed by backpack back to me after I left it on the side of a mountain", 182));
        add_line(chowstring("SOUNDTRACK\r\nThis music is by me but it's temporary\r\nMore at volvadrex.bandcamp.com / soundcloud.com/vol-vadrex", 110));
        add_line(chowstring("SOUNDTRACK\r\nThis music is by me but it's temporary\r\nMore at volvadrex.bandcamp.com / soundcloud.com/vol-vadrex", 110));
        add_line(chowstring("PLAYER\r\nYou!", 12));
        create_alterables();
    }
};
FrameObject * create_string2_43(int x, int y)
{
    return new (Text::pool.create()) String2_43(x, y);
}
static Image* images_active14_44_0_0[4];
static Direction direction_active14_44_0_0 = {0, 20, 20, 0, -1, 4, images_active14_44_0_0};
static Animation anim_active14_44_0 = {&direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, NULL, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0, &direction_active14_44_0_0};
static Animation * anim_array_active14_44[1] = {&anim_active14_44_0};
static Animations anim_active14_44 = {1, &anim_array_active14_44[0]};
static bool anim_active14_44_initialized;
class Active14_44 : public Active
{
public:
    Active14_44(int x, int y) : Active(x, y, Active14_44_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 14", 9);
#endif
        this->animations = &anim_active14_44;
        if (!anim_active14_44_initialized) {
            anim_active14_44_initialized = true;
            images_active14_44_0_0[0] = get_internal_image_direct(479);
            images_active14_44_0_0[1] = get_internal_image_direct(481);
            images_active14_44_0_0[2] = get_internal_image_direct(482);
            images_active14_44_0_0[3] = get_internal_image_direct(481);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active14_44(int x, int y)
{
    return new (Active::pool.create()) Active14_44(x, y);
}
static Image* images_camera_45_0_0[1];
static Direction direction_camera_45_0_0 = {0, 50, 50, 0, 1, 1, images_camera_45_0_0};
static Animation anim_camera_45_0 = {&direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, NULL, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0, &direction_camera_45_0_0};
static Animation * anim_array_camera_45[1] = {&anim_camera_45_0};
static Animations anim_camera_45 = {1, &anim_array_camera_45[0]};
static bool anim_camera_45_initialized;
class Camera_45 : public Active
{
public:
    Camera_45(int x, int y) : Active(x, y, Camera_45_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("camera", 6);
#endif
        set_visible(false);
        this->animations = &anim_camera_45;
        if (!anim_camera_45_initialized) {
            anim_camera_45_initialized = true;
            images_camera_45_0_0[0] = get_internal_image_direct(142);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_camera_45(int x, int y)
{
    return new (Active::pool.create()) Camera_45(x, y);
}
static Image* images_camerachaser_46_0_0[1];
static Direction direction_camerachaser_46_0_0 = {0, 50, 50, 0, 1, 1, images_camerachaser_46_0_0};
static Animation anim_camerachaser_46_0 = {&direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, NULL, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0, &direction_camerachaser_46_0_0};
static Animation * anim_array_camerachaser_46[1] = {&anim_camerachaser_46_0};
static Animations anim_camerachaser_46 = {1, &anim_array_camerachaser_46[0]};
static bool anim_camerachaser_46_initialized;
class CameraChaser_46 : public Active
{
public:
    CameraChaser_46(int x, int y) : Active(x, y, CameraChaser_46_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("camera chaser", 13);
#endif
        set_visible(false);
        this->animations = &anim_camerachaser_46;
        if (!anim_camerachaser_46_initialized) {
            anim_camerachaser_46_initialized = true;
            images_camerachaser_46_0_0[0] = get_internal_image_direct(141);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_camerachaser_46(int x, int y)
{
    return new (Active::pool.create()) CameraChaser_46(x, y);
}
static Image* images_blockmaker_47_0_0[1];
static Direction direction_blockmaker_47_0_0 = {0, 50, 50, 0, 1, 1, images_blockmaker_47_0_0};
static Animation anim_blockmaker_47_0 = {&direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, NULL, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0, &direction_blockmaker_47_0_0};
static Animation * anim_array_blockmaker_47[1] = {&anim_blockmaker_47_0};
static Animations anim_blockmaker_47 = {1, &anim_array_blockmaker_47[0]};
static bool anim_blockmaker_47_initialized;
class Blockmaker_47 : public Active
{
public:
    Blockmaker_47(int x, int y) : Active(x, y, Blockmaker_47_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("blockmaker", 10);
#endif
        this->animations = &anim_blockmaker_47;
        if (!anim_blockmaker_47_initialized) {
            anim_blockmaker_47_initialized = true;
            images_blockmaker_47_0_0[0] = get_internal_image_direct(7);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_blockmaker_47(int x, int y)
{
    return new (Active::pool.create()) Blockmaker_47(x, y);
}
static Image* images_roadmaker_48_0_0[1];
static Direction direction_roadmaker_48_0_0 = {0, 50, 50, 0, 1, 1, images_roadmaker_48_0_0};
static Animation anim_roadmaker_48_0 = {&direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, NULL, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0, &direction_roadmaker_48_0_0};
static Animation * anim_array_roadmaker_48[1] = {&anim_roadmaker_48_0};
static Animations anim_roadmaker_48 = {1, &anim_array_roadmaker_48[0]};
static bool anim_roadmaker_48_initialized;
class Roadmaker_48 : public Active
{
public:
    Roadmaker_48(int x, int y) : Active(x, y, Roadmaker_48_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("roadmaker", 9);
#endif
        this->animations = &anim_roadmaker_48;
        if (!anim_roadmaker_48_initialized) {
            anim_roadmaker_48_initialized = true;
            images_roadmaker_48_0_0[0] = get_internal_image_direct(7);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_roadmaker_48(int x, int y)
{
    return new (Active::pool.create()) Roadmaker_48(x, y);
}
static Image* images_active15_49_0_0[1];
static Direction direction_active15_49_0_0 = {0, 50, 50, 0, 1, 1, images_active15_49_0_0};
static Animation anim_active15_49_0 = {&direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, NULL, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0, &direction_active15_49_0_0};
static Animation * anim_array_active15_49[1] = {&anim_active15_49_0};
static Animations anim_active15_49 = {1, &anim_array_active15_49[0]};
static bool anim_active15_49_initialized;
class Active15_49 : public Active
{
public:
    Active15_49(int x, int y) : Active(x, y, Active15_49_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 15", 9);
#endif
        this->animations = &anim_active15_49;
        if (!anim_active15_49_initialized) {
            anim_active15_49_initialized = true;
            images_active15_49_0_0[0] = get_internal_image_direct(7);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active15_49(int x, int y)
{
    return new (Active::pool.create()) Active15_49(x, y);
}
static Image* images_roadlimit_50_0_0[1];
static Direction direction_roadlimit_50_0_0 = {0, 50, 50, 0, 1, 1, images_roadlimit_50_0_0};
static Animation anim_roadlimit_50_0 = {&direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, NULL, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0, &direction_roadlimit_50_0_0};
static Animation * anim_array_roadlimit_50[1] = {&anim_roadlimit_50_0};
static Animations anim_roadlimit_50 = {1, &anim_array_roadlimit_50[0]};
static bool anim_roadlimit_50_initialized;
class Roadlimit_50 : public Active
{
public:
    Roadlimit_50(int x, int y) : Active(x, y, Roadlimit_50_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("roadlimit", 9);
#endif
        this->animations = &anim_roadlimit_50;
        if (!anim_roadlimit_50_initialized) {
            anim_roadlimit_50_initialized = true;
            images_roadlimit_50_0_0[0] = get_internal_image_direct(7);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_roadlimit_50(int x, int y)
{
    return new (Active::pool.create()) Roadlimit_50(x, y);
}
static Image* images_lginitpos_51_0_0[1];
static Direction direction_lginitpos_51_0_0 = {0, 50, 50, 0, 1, 1, images_lginitpos_51_0_0};
static Animation anim_lginitpos_51_0 = {&direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, NULL, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0, &direction_lginitpos_51_0_0};
static Animation * anim_array_lginitpos_51[1] = {&anim_lginitpos_51_0};
static Animations anim_lginitpos_51 = {1, &anim_array_lginitpos_51[0]};
static bool anim_lginitpos_51_initialized;
class Lginitpos_51 : public Active
{
public:
    Lginitpos_51(int x, int y) : Active(x, y, Lginitpos_51_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("lginitpos", 9);
#endif
        set_visible(false);
        this->animations = &anim_lginitpos_51;
        if (!anim_lginitpos_51_initialized) {
            anim_lginitpos_51_initialized = true;
            images_lginitpos_51_0_0[0] = get_internal_image_direct(7);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_lginitpos_51(int x, int y)
{
    return new (Active::pool.create()) Lginitpos_51(x, y);
}
class Backdrop2_52 : public Backdrop
{
public:
    Backdrop2_52(int x, int y) : Backdrop(x, y, BACKGROUND_TYPE)
    {
#ifndef NDEBUG
        name = chowstring("Backdrop 2", 10);
#endif
        flags |= BACKGROUND;
        flags |= BACKGROUND_COL;
#ifdef BACK_ID_BACKDROP_2
        manager.frame->back_instances[BACK_ID_BACKDROP_2].push_back(this);
#endif
        image = get_internal_image(464);
        width = image->width;
        height = image->height;
    }
};
FrameObject * create_backdrop2_52(int x, int y)
{
    return new (Backdrop::pool.create()) Backdrop2_52(x, y);
}
class Backdrop3_53 : public Backdrop
{
public:
    Backdrop3_53(int x, int y) : Backdrop(x, y, BACKGROUND_TYPE)
    {
#ifndef NDEBUG
        name = chowstring("Backdrop 3", 10);
#endif
        flags |= BACKGROUND;
        flags |= BACKGROUND_COL;
#ifdef BACK_ID_BACKDROP_3
        manager.frame->back_instances[BACK_ID_BACKDROP_3].push_back(this);
#endif
        image = get_internal_image(798);
        width = image->width;
        height = image->height;
    }
};
FrameObject * create_backdrop3_53(int x, int y)
{
    return new (Backdrop::pool.create()) Backdrop3_53(x, y);
}
class Backdrop4_54 : public Backdrop
{
public:
    Backdrop4_54(int x, int y) : Backdrop(x, y, BACKGROUND_TYPE)
    {
#ifndef NDEBUG
        name = chowstring("Backdrop 4", 10);
#endif
        flags |= BACKGROUND;
        flags |= BACKGROUND_COL;
#ifdef BACK_ID_BACKDROP_4
        manager.frame->back_instances[BACK_ID_BACKDROP_4].push_back(this);
#endif
        image = get_internal_image(833);
        width = image->width;
        height = image->height;
    }
};
FrameObject * create_backdrop4_54(int x, int y)
{
    return new (Backdrop::pool.create()) Backdrop4_54(x, y);
}
class Backdrop5_55 : public Backdrop
{
public:
    Backdrop5_55(int x, int y) : Backdrop(x, y, BACKGROUND_TYPE)
    {
#ifndef NDEBUG
        name = chowstring("Backdrop 5", 10);
#endif
        flags |= BACKGROUND;
        flags |= BACKGROUND_COL;
#ifdef BACK_ID_BACKDROP_5
        manager.frame->back_instances[BACK_ID_BACKDROP_5].push_back(this);
#endif
        image = get_internal_image(556);
        width = image->width;
        height = image->height;
    }
};
FrameObject * create_backdrop5_55(int x, int y)
{
    return new (Backdrop::pool.create()) Backdrop5_55(x, y);
}
class Backdrop6_56 : public Backdrop
{
public:
    Backdrop6_56(int x, int y) : Backdrop(x, y, BACKGROUND_TYPE)
    {
#ifndef NDEBUG
        name = chowstring("Backdrop 6", 10);
#endif
        flags |= BACKGROUND;
        flags |= BACKGROUND_COL;
#ifdef BACK_ID_BACKDROP_6
        manager.frame->back_instances[BACK_ID_BACKDROP_6].push_back(this);
#endif
        image = get_internal_image(799);
        width = image->width;
        height = image->height;
    }
};
FrameObject * create_backdrop6_56(int x, int y)
{
    return new (Backdrop::pool.create()) Backdrop6_56(x, y);
}
class QuickBackdrop2_57 : public QuickBackdrop
{
public:
    QuickBackdrop2_57(int x, int y) : QuickBackdrop(x, y, BACKGROUND_TYPE)
    {
#ifndef NDEBUG
        name = chowstring("Quick Backdrop 2", 16);
#endif
        flags |= BACKGROUND;
        flags |= BACKGROUND_COL;
        width = 640;
        height = 30;
        image = get_internal_image(470);
        outline = 0;
    }
};
FrameObject * create_quickbackdrop2_57(int x, int y)
{
    return new (QuickBackdrop::pool.create()) QuickBackdrop2_57(x, y);
}
class QuickBackdrop3_58 : public QuickBackdrop
{
public:
    QuickBackdrop3_58(int x, int y) : QuickBackdrop(x, y, BACKGROUND_TYPE)
    {
#ifndef NDEBUG
        name = chowstring("Quick Backdrop 3", 16);
#endif
        flags |= BACKGROUND;
        flags |= BACKGROUND_COL;
        width = 640;
        height = 100;
        image = get_internal_image(462);
        outline = 0;
    }
};
FrameObject * create_quickbackdrop3_58(int x, int y)
{
    return new (QuickBackdrop::pool.create()) QuickBackdrop3_58(x, y);
}
class String3_59 : public Text
{
public:
    String3_59(int x, int y) : Text(x, y, String3_59_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("String 3", 8);
#endif
        flags &= ~SCROLL;
        width = 160;
        height = 93;
        blend_color = Color(255, 255, 255);
        bold = false;
        italic = false;
        font_name = chowstring("Small Fonts", 11);
        font = get_font(7, 0);
        alignment = ALIGN_LEFT | ALIGN_TOP;
        add_line(chowstring("Lawyer Guy is a jumping and shooting action game, so make sure to jump and shoot whenever possible.", 99));
        create_alterables();
    }
};
FrameObject * create_string3_59(int x, int y)
{
    return new (Text::pool.create()) String3_59(x, y);
}
class String4_60 : public Text
{
public:
    String4_60(int x, int y) : Text(x, y, String4_60_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("String 4", 8);
#endif
        flags &= ~SCROLL;
        width = 176;
        height = 93;
        blend_color = Color(255, 255, 255);
        bold = false;
        italic = false;
        font_name = chowstring("Small Fonts", 11);
        font = get_font(7, 0);
        alignment = ALIGN_LEFT | ALIGN_TOP;
        add_line(chowstring("Two kinds of bonus lives are available. Play without dying, or beat the level as fast as possible and you'll be rewarded with extra lives periodically!", 151));
        create_alterables();
    }
};
FrameObject * create_string4_60(int x, int y)
{
    return new (Text::pool.create()) String4_60(x, y);
}
class String5_61 : public Text
{
public:
    String5_61(int x, int y) : Text(x, y, String5_61_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("String 5", 8);
#endif
        flags &= ~SCROLL;
        width = 178;
        height = 93;
        blend_color = Color(255, 255, 255);
        bold = false;
        italic = false;
        font_name = chowstring("Small Fonts", 11);
        font = get_font(7, 0);
        alignment = ALIGN_LEFT | ALIGN_TOP;
        add_line(chowstring("Hold to quit the game", 21));
        create_alterables();
    }
};
FrameObject * create_string5_61(int x, int y)
{
    return new (Text::pool.create()) String5_61(x, y);
}
class Backdrop9_62 : public Backdrop
{
public:
    Backdrop9_62(int x, int y) : Backdrop(x, y, BACKGROUND_TYPE)
    {
#ifndef NDEBUG
        name = chowstring("Backdrop 9", 10);
#endif
        flags |= BACKGROUND;
        flags |= BACKGROUND_COL;
#ifdef BACK_ID_BACKDROP_9
        manager.frame->back_instances[BACK_ID_BACKDROP_9].push_back(this);
#endif
        image = get_internal_image(469);
        width = image->width;
        height = image->height;
    }
};
FrameObject * create_backdrop9_62(int x, int y)
{
    return new (Backdrop::pool.create()) Backdrop9_62(x, y);
}
static Image* images_menudatastore_63_0_0[1];
static Direction direction_menudatastore_63_0_0 = {0, 50, 50, 0, 1, 1, images_menudatastore_63_0_0};
static Animation anim_menudatastore_63_0 = {&direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, NULL, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0, &direction_menudatastore_63_0_0};
static Animation * anim_array_menudatastore_63[1] = {&anim_menudatastore_63_0};
static Animations anim_menudatastore_63 = {1, &anim_array_menudatastore_63[0]};
static bool anim_menudatastore_63_initialized;
class MenuDataStore_63 : public Active
{
public:
    MenuDataStore_63(int x, int y) : Active(x, y, MenuDataStore_63_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("MenuDataStore", 13);
#endif
        this->animations = &anim_menudatastore_63;
        if (!anim_menudatastore_63_initialized) {
            anim_menudatastore_63_initialized = true;
            images_menudatastore_63_0_0[0] = get_internal_image_direct(7);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
        alterables->strings.set(0, str_play_0);
        alterables->strings.set(1, str_main_1);
        alterables->strings.set(2, str_edit_controls_2);
    }
};
FrameObject * create_menudatastore_63(int x, int y)
{
    return new (Active::pool.create()) MenuDataStore_63(x, y);
}
static Image* images_graphicdashtype_64_0_0[1];
static Direction direction_graphicdashtype_64_0_0 = {0, 50, 50, 0, 1, 1, images_graphicdashtype_64_0_0};
static Animation anim_graphicdashtype_64_0 = {&direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, NULL, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0, &direction_graphicdashtype_64_0_0};
static Image* images_graphicdashtype_64_1_0[1];
static Direction direction_graphicdashtype_64_1_0 = {0, 50, 50, 0, 1, 1, images_graphicdashtype_64_1_0};
static Animation anim_graphicdashtype_64_1 = {&direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, NULL, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0, &direction_graphicdashtype_64_1_0};
static Animation * anim_array_graphicdashtype_64[2] = {&anim_graphicdashtype_64_0, &anim_graphicdashtype_64_1};
static Animations anim_graphicdashtype_64 = {2, &anim_array_graphicdashtype_64[0]};
static bool anim_graphicdashtype_64_initialized;
class GraphicDashtype_64 : public Active
{
public:
    GraphicDashtype_64(int x, int y) : Active(x, y, GraphicDashtype_64_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("graphic-dashtype", 16);
#endif
        this->animations = &anim_graphicdashtype_64;
        if (!anim_graphicdashtype_64_initialized) {
            anim_graphicdashtype_64_initialized = true;
            images_graphicdashtype_64_0_0[0] = get_internal_image_direct(485);
            images_graphicdashtype_64_1_0[0] = get_internal_image_direct(484);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_graphicdashtype_64(int x, int y)
{
    return new (Active::pool.create()) GraphicDashtype_64(x, y);
}
static Image* images_active16_65_0_0[1];
static Direction direction_active16_65_0_0 = {0, 50, 50, 0, 1, 1, images_active16_65_0_0};
static Animation anim_active16_65_0 = {&direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, NULL, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0, &direction_active16_65_0_0};
static Animation * anim_array_active16_65[1] = {&anim_active16_65_0};
static Animations anim_active16_65 = {1, &anim_array_active16_65[0]};
static bool anim_active16_65_initialized;
class Active16_65 : public Active
{
public:
    Active16_65(int x, int y) : Active(x, y, Active16_65_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 16", 9);
#endif
        this->animations = &anim_active16_65;
        if (!anim_active16_65_initialized) {
            anim_active16_65_initialized = true;
            images_active16_65_0_0[0] = get_internal_image_direct(498);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active16_65(int x, int y)
{
    return new (Active::pool.create()) Active16_65(x, y);
}
static Image* images_active17_66_0_0[1];
static Direction direction_active17_66_0_0 = {0, 50, 50, 0, 1, 1, images_active17_66_0_0};
static Animation anim_active17_66_0 = {&direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, NULL, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0, &direction_active17_66_0_0};
static Animation * anim_array_active17_66[1] = {&anim_active17_66_0};
static Animations anim_active17_66 = {1, &anim_array_active17_66[0]};
static bool anim_active17_66_initialized;
class Active17_66 : public Active
{
public:
    Active17_66(int x, int y) : Active(x, y, Active17_66_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 17", 9);
#endif
        this->animations = &anim_active17_66;
        if (!anim_active17_66_initialized) {
            anim_active17_66_initialized = true;
            images_active17_66_0_0[0] = get_internal_image_direct(489);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active17_66(int x, int y)
{
    return new (Active::pool.create()) Active17_66(x, y);
}
static Image* images_graphicscreenshake_67_0_0[1];
static Direction direction_graphicscreenshake_67_0_0 = {0, 50, 50, 0, 1, 1, images_graphicscreenshake_67_0_0};
static Animation anim_graphicscreenshake_67_0 = {&direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, NULL, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0, &direction_graphicscreenshake_67_0_0};
static Image* images_graphicscreenshake_67_1_0[1];
static Direction direction_graphicscreenshake_67_1_0 = {0, 50, 50, 0, 1, 1, images_graphicscreenshake_67_1_0};
static Animation anim_graphicscreenshake_67_1 = {&direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, NULL, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0, &direction_graphicscreenshake_67_1_0};
static Animation * anim_array_graphicscreenshake_67[2] = {&anim_graphicscreenshake_67_0, &anim_graphicscreenshake_67_1};
static Animations anim_graphicscreenshake_67 = {2, &anim_array_graphicscreenshake_67[0]};
static bool anim_graphicscreenshake_67_initialized;
class GraphicScreenshake_67 : public Active
{
public:
    GraphicScreenshake_67(int x, int y) : Active(x, y, GraphicScreenshake_67_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("graphic-screenshake", 19);
#endif
        this->animations = &anim_graphicscreenshake_67;
        if (!anim_graphicscreenshake_67_initialized) {
            anim_graphicscreenshake_67_initialized = true;
            images_graphicscreenshake_67_0_0[0] = get_internal_image_direct(492);
            images_graphicscreenshake_67_1_0[0] = get_internal_image_direct(497);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_graphicscreenshake_67(int x, int y)
{
    return new (Active::pool.create()) GraphicScreenshake_67(x, y);
}
static Image* images_active20_68_0_0[1];
static Direction direction_active20_68_0_0 = {0, 50, 50, 0, 1, 1, images_active20_68_0_0};
static Animation anim_active20_68_0 = {&direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, NULL, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0, &direction_active20_68_0_0};
static Animation * anim_array_active20_68[1] = {&anim_active20_68_0};
static Animations anim_active20_68 = {1, &anim_array_active20_68[0]};
static bool anim_active20_68_initialized;
class Active20_68 : public Active
{
public:
    Active20_68(int x, int y) : Active(x, y, Active20_68_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 20", 9);
#endif
        this->animations = &anim_active20_68;
        if (!anim_active20_68_initialized) {
            anim_active20_68_initialized = true;
            images_active20_68_0_0[0] = get_internal_image_direct(474);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active20_68(int x, int y)
{
    return new (Active::pool.create()) Active20_68(x, y);
}
static Image* images_active21_69_0_0[1];
static Direction direction_active21_69_0_0 = {0, 50, 50, 0, 1, 1, images_active21_69_0_0};
static Animation anim_active21_69_0 = {&direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, NULL, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0, &direction_active21_69_0_0};
static Animation * anim_array_active21_69[1] = {&anim_active21_69_0};
static Animations anim_active21_69 = {1, &anim_array_active21_69[0]};
static bool anim_active21_69_initialized;
class Active21_69 : public Active
{
public:
    Active21_69(int x, int y) : Active(x, y, Active21_69_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 21", 9);
#endif
        this->animations = &anim_active21_69;
        if (!anim_active21_69_initialized) {
            anim_active21_69_initialized = true;
            images_active21_69_0_0[0] = get_internal_image_direct(476);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active21_69(int x, int y)
{
    return new (Active::pool.create()) Active21_69(x, y);
}
static Image* images_active22_70_0_0[1];
static Direction direction_active22_70_0_0 = {0, 50, 50, 0, 1, 1, images_active22_70_0_0};
static Animation anim_active22_70_0 = {&direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, NULL, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0, &direction_active22_70_0_0};
static Animation * anim_array_active22_70[1] = {&anim_active22_70_0};
static Animations anim_active22_70 = {1, &anim_array_active22_70[0]};
static bool anim_active22_70_initialized;
class Active22_70 : public Active
{
public:
    Active22_70(int x, int y) : Active(x, y, Active22_70_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 22", 9);
#endif
        this->animations = &anim_active22_70;
        if (!anim_active22_70_initialized) {
            anim_active22_70_initialized = true;
            images_active22_70_0_0[0] = get_internal_image_direct(483);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active22_70(int x, int y)
{
    return new (Active::pool.create()) Active22_70(x, y);
}
class Backdrop10_71 : public Backdrop
{
public:
    Backdrop10_71(int x, int y) : Backdrop(x, y, BACKGROUND_TYPE)
    {
#ifndef NDEBUG
        name = chowstring("Backdrop 10", 11);
#endif
        flags |= BACKGROUND;
        flags |= BACKGROUND_COL;
#ifdef BACK_ID_BACKDROP_10
        manager.frame->back_instances[BACK_ID_BACKDROP_10].push_back(this);
#endif
        image = get_internal_image(382);
        width = image->width;
        height = image->height;
    }
};
FrameObject * create_backdrop10_71(int x, int y)
{
    return new (Backdrop::pool.create()) Backdrop10_71(x, y);
}
static Image* images_active23_72_0_0[1];
static Direction direction_active23_72_0_0 = {0, 50, 50, 0, 1, 1, images_active23_72_0_0};
static Animation anim_active23_72_0 = {&direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, NULL, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0, &direction_active23_72_0_0};
static Animation * anim_array_active23_72[1] = {&anim_active23_72_0};
static Animations anim_active23_72 = {1, &anim_array_active23_72[0]};
static bool anim_active23_72_initialized;
class Active23_72 : public Active
{
public:
    Active23_72(int x, int y) : Active(x, y, Active23_72_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 23", 9);
#endif
        this->animations = &anim_active23_72;
        if (!anim_active23_72_initialized) {
            anim_active23_72_initialized = true;
            images_active23_72_0_0[0] = get_internal_image_direct(496);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active23_72(int x, int y)
{
    return new (Active::pool.create()) Active23_72(x, y);
}
static Image* images_active24_73_0_0[1];
static Direction direction_active24_73_0_0 = {0, 50, 50, 0, 1, 1, images_active24_73_0_0};
static Animation anim_active24_73_0 = {&direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, NULL, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0, &direction_active24_73_0_0};
static Animation * anim_array_active24_73[1] = {&anim_active24_73_0};
static Animations anim_active24_73 = {1, &anim_array_active24_73[0]};
static bool anim_active24_73_initialized;
class Active24_73 : public Active
{
public:
    Active24_73(int x, int y) : Active(x, y, Active24_73_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 24", 9);
#endif
        this->animations = &anim_active24_73;
        if (!anim_active24_73_initialized) {
            anim_active24_73_initialized = true;
            images_active24_73_0_0[0] = get_internal_image_direct(490);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active24_73(int x, int y)
{
    return new (Active::pool.create()) Active24_73(x, y);
}
static Image* images_active25_74_0_0[4];
static Direction direction_active25_74_0_0 = {0, 20, 20, 0, -1, 4, images_active25_74_0_0};
static Animation anim_active25_74_0 = {&direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, NULL, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0, &direction_active25_74_0_0};
static Animation * anim_array_active25_74[1] = {&anim_active25_74_0};
static Animations anim_active25_74 = {1, &anim_array_active25_74[0]};
static bool anim_active25_74_initialized;
class Active25_74 : public Active
{
public:
    Active25_74(int x, int y) : Active(x, y, Active25_74_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 25", 9);
#endif
        this->animations = &anim_active25_74;
        if (!anim_active25_74_initialized) {
            anim_active25_74_initialized = true;
            images_active25_74_0_0[0] = get_internal_image_direct(503);
            images_active25_74_0_0[1] = get_internal_image_direct(504);
            images_active25_74_0_0[2] = get_internal_image_direct(505);
            images_active25_74_0_0[3] = get_internal_image_direct(504);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active25_74(int x, int y)
{
    return new (Active::pool.create()) Active25_74(x, y);
}
static Image* images_musicslider_75_0_0[1];
static Direction direction_musicslider_75_0_0 = {0, 50, 50, 0, 1, 1, images_musicslider_75_0_0};
static Animation anim_musicslider_75_0 = {&direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, NULL, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0, &direction_musicslider_75_0_0};
static Animation * anim_array_musicslider_75[1] = {&anim_musicslider_75_0};
static Animations anim_musicslider_75 = {1, &anim_array_musicslider_75[0]};
static bool anim_musicslider_75_initialized;
class MusicSlider_75 : public Active
{
public:
    MusicSlider_75(int x, int y) : Active(x, y, MusicSlider_75_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("MusicSlider", 11);
#endif
        this->animations = &anim_musicslider_75;
        if (!anim_musicslider_75_initialized) {
            anim_musicslider_75_initialized = true;
            images_musicslider_75_0_0[0] = get_internal_image_direct(502);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_musicslider_75(int x, int y)
{
    return new (Active::pool.create()) MusicSlider_75(x, y);
}
static Image* images_musicsliderindicator_76_0_0[1];
static Direction direction_musicsliderindicator_76_0_0 = {0, 50, 50, 0, 1, 1, images_musicsliderindicator_76_0_0};
static Animation anim_musicsliderindicator_76_0 = {&direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, NULL, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0, &direction_musicsliderindicator_76_0_0};
static Animation * anim_array_musicsliderindicator_76[1] = {&anim_musicsliderindicator_76_0};
static Animations anim_musicsliderindicator_76 = {1, &anim_array_musicsliderindicator_76[0]};
static bool anim_musicsliderindicator_76_initialized;
class MusicSliderIndicator_76 : public Active
{
public:
    MusicSliderIndicator_76(int x, int y) : Active(x, y, MusicSliderIndicator_76_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("MusicSliderIndicator", 20);
#endif
        this->animations = &anim_musicsliderindicator_76;
        if (!anim_musicsliderindicator_76_initialized) {
            anim_musicsliderindicator_76_initialized = true;
            images_musicsliderindicator_76_0_0[0] = get_internal_image_direct(502);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_musicsliderindicator_76(int x, int y)
{
    return new (Active::pool.create()) MusicSliderIndicator_76(x, y);
}
static Image* images_active18_77_0_0[1];
static Direction direction_active18_77_0_0 = {0, 50, 50, 0, 1, 1, images_active18_77_0_0};
static Animation anim_active18_77_0 = {&direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, NULL, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0, &direction_active18_77_0_0};
static Animation * anim_array_active18_77[1] = {&anim_active18_77_0};
static Animations anim_active18_77 = {1, &anim_array_active18_77[0]};
static bool anim_active18_77_initialized;
class Active18_77 : public Active
{
public:
    Active18_77(int x, int y) : Active(x, y, Active18_77_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 18", 9);
#endif
        this->animations = &anim_active18_77;
        if (!anim_active18_77_initialized) {
            anim_active18_77_initialized = true;
            images_active18_77_0_0[0] = get_internal_image_direct(464);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active18_77(int x, int y)
{
    return new (Active::pool.create()) Active18_77(x, y);
}
static Image* images_active26_78_0_0[4];
static Direction direction_active26_78_0_0 = {0, 20, 20, 0, -1, 4, images_active26_78_0_0};
static Animation anim_active26_78_0 = {&direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, NULL, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0, &direction_active26_78_0_0};
static Animation * anim_array_active26_78[1] = {&anim_active26_78_0};
static Animations anim_active26_78 = {1, &anim_array_active26_78[0]};
static bool anim_active26_78_initialized;
class Active26_78 : public Active
{
public:
    Active26_78(int x, int y) : Active(x, y, Active26_78_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 26", 9);
#endif
        this->animations = &anim_active26_78;
        if (!anim_active26_78_initialized) {
            anim_active26_78_initialized = true;
            images_active26_78_0_0[0] = get_internal_image_direct(529);
            images_active26_78_0_0[1] = get_internal_image_direct(534);
            images_active26_78_0_0[2] = get_internal_image_direct(537);
            images_active26_78_0_0[3] = get_internal_image_direct(534);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active26_78(int x, int y)
{
    return new (Active::pool.create()) Active26_78(x, y);
}
class String6_79 : public Text
{
public:
    String6_79(int x, int y) : Text(x, y, String6_79_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("String 6", 8);
#endif
        flags &= ~SCROLL;
        width = 176;
        height = 93;
        blend_color = Color(255, 255, 255);
        bold = false;
        italic = false;
        font_name = chowstring("Small Fonts", 11);
        font = get_font(7, 0);
        alignment = ALIGN_LEFT | ALIGN_TOP;
        add_line(chowstring("No overlay", 10));
        create_alterables();
    }
};
FrameObject * create_string6_79(int x, int y)
{
    return new (Text::pool.create()) String6_79(x, y);
}
static Image* images_active6_80_0_0[1];
static Direction direction_active6_80_0_0 = {0, 50, 50, 0, 1, 1, images_active6_80_0_0};
static Animation anim_active6_80_0 = {&direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, NULL, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0, &direction_active6_80_0_0};
static Image* images_active6_80_1_0[1];
static Direction direction_active6_80_1_0 = {0, 50, 50, 0, 1, 1, images_active6_80_1_0};
static Animation anim_active6_80_1 = {&direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, NULL, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0, &direction_active6_80_1_0};
static Image* images_active6_80_2_0[1];
static Direction direction_active6_80_2_0 = {0, 50, 50, 0, 1, 1, images_active6_80_2_0};
static Animation anim_active6_80_2 = {&direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, NULL, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0, &direction_active6_80_2_0};
static Animation * anim_array_active6_80[3] = {&anim_active6_80_0, &anim_active6_80_1, &anim_active6_80_2};
static Animations anim_active6_80 = {3, &anim_array_active6_80[0]};
static bool anim_active6_80_initialized;
class Active6_80 : public Active
{
public:
    Active6_80(int x, int y) : Active(x, y, Active6_80_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 6", 8);
#endif
        this->animations = &anim_active6_80;
        if (!anim_active6_80_initialized) {
            anim_active6_80_initialized = true;
            images_active6_80_0_0[0] = get_internal_image_direct(968);
            images_active6_80_1_0[0] = get_internal_image_direct(539);
            images_active6_80_2_0[0] = get_internal_image_direct(979);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active6_80(int x, int y)
{
    return new (Active::pool.create()) Active6_80(x, y);
}
static Image* images_active19_81_0_0[1];
static Direction direction_active19_81_0_0 = {0, 50, 50, 0, 1, 1, images_active19_81_0_0};
static Animation anim_active19_81_0 = {&direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, NULL, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0, &direction_active19_81_0_0};
static Animation * anim_array_active19_81[1] = {&anim_active19_81_0};
static Animations anim_active19_81 = {1, &anim_array_active19_81[0]};
static bool anim_active19_81_initialized;
class Active19_81 : public Active
{
public:
    Active19_81(int x, int y) : Active(x, y, Active19_81_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 19", 9);
#endif
        this->animations = &anim_active19_81;
        if (!anim_active19_81_initialized) {
            anim_active19_81_initialized = true;
            images_active19_81_0_0[0] = get_internal_image_direct(905);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active19_81(int x, int y)
{
    return new (Active::pool.create()) Active19_81(x, y);
}
static Image* images_active27_82_0_0[1];
static Direction direction_active27_82_0_0 = {0, 50, 50, 0, 1, 1, images_active27_82_0_0};
static Animation anim_active27_82_0 = {&direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, NULL, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0, &direction_active27_82_0_0};
static Animation * anim_array_active27_82[1] = {&anim_active27_82_0};
static Animations anim_active27_82 = {1, &anim_array_active27_82[0]};
static bool anim_active27_82_initialized;
class Active27_82 : public Active
{
public:
    Active27_82(int x, int y) : Active(x, y, Active27_82_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 27", 9);
#endif
        this->animations = &anim_active27_82;
        if (!anim_active27_82_initialized) {
            anim_active27_82_initialized = true;
            images_active27_82_0_0[0] = get_internal_image_direct(553);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active27_82(int x, int y)
{
    return new (Active::pool.create()) Active27_82(x, y);
}
static Image* images_active28_83_0_0[1];
static Direction direction_active28_83_0_0 = {0, 50, 50, 0, 1, 1, images_active28_83_0_0};
static Animation anim_active28_83_0 = {&direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, NULL, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0, &direction_active28_83_0_0};
static Animation * anim_array_active28_83[1] = {&anim_active28_83_0};
static Animations anim_active28_83 = {1, &anim_array_active28_83[0]};
static bool anim_active28_83_initialized;
class Active28_83 : public Active
{
public:
    Active28_83(int x, int y) : Active(x, y, Active28_83_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 28", 9);
#endif
        this->animations = &anim_active28_83;
        if (!anim_active28_83_initialized) {
            anim_active28_83_initialized = true;
            images_active28_83_0_0[0] = get_internal_image_direct(552);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active28_83(int x, int y)
{
    return new (Active::pool.create()) Active28_83(x, y);
}
static Image* images_active29_84_0_0[1];
static Direction direction_active29_84_0_0 = {0, 50, 50, 0, 1, 1, images_active29_84_0_0};
static Animation anim_active29_84_0 = {&direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, NULL, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0, &direction_active29_84_0_0};
static Animation * anim_array_active29_84[1] = {&anim_active29_84_0};
static Animations anim_active29_84 = {1, &anim_array_active29_84[0]};
static bool anim_active29_84_initialized;
class Active29_84 : public Active
{
public:
    Active29_84(int x, int y) : Active(x, y, Active29_84_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 29", 9);
#endif
        this->animations = &anim_active29_84;
        if (!anim_active29_84_initialized) {
            anim_active29_84_initialized = true;
            images_active29_84_0_0[0] = get_internal_image_direct(971);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active29_84(int x, int y)
{
    return new (Active::pool.create()) Active29_84(x, y);
}
static Image* images_active30_85_0_0[1];
static Direction direction_active30_85_0_0 = {0, 50, 50, 0, 1, 1, images_active30_85_0_0};
static Animation anim_active30_85_0 = {&direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, NULL, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0, &direction_active30_85_0_0};
static Image* images_active30_85_1_0[1];
static Direction direction_active30_85_1_0 = {0, 50, 50, 0, 1, 1, images_active30_85_1_0};
static Animation anim_active30_85_1 = {&direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, NULL, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0, &direction_active30_85_1_0};
static Animation * anim_array_active30_85[2] = {&anim_active30_85_0, &anim_active30_85_1};
static Animations anim_active30_85 = {2, &anim_array_active30_85[0]};
static bool anim_active30_85_initialized;
class Active30_85 : public Active
{
public:
    Active30_85(int x, int y) : Active(x, y, Active30_85_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 30", 9);
#endif
        this->animations = &anim_active30_85;
        if (!anim_active30_85_initialized) {
            anim_active30_85_initialized = true;
            images_active30_85_0_0[0] = get_internal_image_direct(969);
            images_active30_85_1_0[0] = get_internal_image_direct(973);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active30_85(int x, int y)
{
    return new (Active::pool.create()) Active30_85(x, y);
}
static Image* images_active31_86_0_0[1];
static Direction direction_active31_86_0_0 = {0, 50, 50, 0, 1, 1, images_active31_86_0_0};
static Animation anim_active31_86_0 = {&direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, NULL, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0, &direction_active31_86_0_0};
static Animation * anim_array_active31_86[1] = {&anim_active31_86_0};
static Animations anim_active31_86 = {1, &anim_array_active31_86[0]};
static bool anim_active31_86_initialized;
class Active31_86 : public Active
{
public:
    Active31_86(int x, int y) : Active(x, y, Active31_86_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 31", 9);
#endif
        this->animations = &anim_active31_86;
        if (!anim_active31_86_initialized) {
            anim_active31_86_initialized = true;
            images_active31_86_0_0[0] = get_internal_image_direct(976);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active31_86(int x, int y)
{
    return new (Active::pool.create()) Active31_86(x, y);
}
class String7_87 : public Text
{
public:
    String7_87(int x, int y) : Text(x, y, String7_87_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("String 7", 8);
#endif
        flags &= ~SCROLL;
        width = 235;
        height = 93;
        blend_color = Color(255, 255, 255);
        bold = false;
        italic = false;
        font_name = chowstring("Small Fonts", 11);
        font = get_font(7, 0);
        alignment = ALIGN_LEFT | ALIGN_TOP;
        add_line(chowstring("No ", 3));
        create_alterables();
    }
};
FrameObject * create_string7_87(int x, int y)
{
    return new (Text::pool.create()) String7_87(x, y);
}
static Image* images_active32_88_0_0[1];
static Direction direction_active32_88_0_0 = {0, 50, 50, 0, 1, 1, images_active32_88_0_0};
static Animation anim_active32_88_0 = {&direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, NULL, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0, &direction_active32_88_0_0};
static Animation * anim_array_active32_88[1] = {&anim_active32_88_0};
static Animations anim_active32_88 = {1, &anim_array_active32_88[0]};
static bool anim_active32_88_initialized;
class Active32_88 : public Active
{
public:
    Active32_88(int x, int y) : Active(x, y, Active32_88_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 32", 9);
#endif
        this->animations = &anim_active32_88;
        if (!anim_active32_88_initialized) {
            anim_active32_88_initialized = true;
            images_active32_88_0_0[0] = get_internal_image_direct(1078);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active32_88(int x, int y)
{
    return new (Active::pool.create()) Active32_88(x, y);
}
static Image* images_active12_89_0_0[1];
static Direction direction_active12_89_0_0 = {0, 50, 50, 0, 1, 1, images_active12_89_0_0};
static Animation anim_active12_89_0 = {&direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, NULL, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0, &direction_active12_89_0_0};
static Animation * anim_array_active12_89[1] = {&anim_active12_89_0};
static Animations anim_active12_89 = {1, &anim_array_active12_89[0]};
static bool anim_active12_89_initialized;
class Active12_89 : public Active
{
public:
    Active12_89(int x, int y) : Active(x, y, Active12_89_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Active 12", 9);
#endif
        this->animations = &anim_active12_89;
        if (!anim_active12_89_initialized) {
            anim_active12_89_initialized = true;
            images_active12_89_0_0[0] = get_internal_image_direct(9);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_active12_89(int x, int y)
{
    return new (Active::pool.create()) Active12_89(x, y);
}
static Image* images_notregular_90_0_0[1];
static Direction direction_notregular_90_0_0 = {0, 5, 5, 0, -1, 1, images_notregular_90_0_0};
static Image* images_notregular_90_0_16[1];
static Direction direction_notregular_90_0_16 = {16, 5, 5, 0, -1, 1, images_notregular_90_0_16};
static Animation anim_notregular_90_0 = {&direction_notregular_90_0_0, &direction_notregular_90_0_0, &direction_notregular_90_0_0, &direction_notregular_90_0_0, &direction_notregular_90_0_0, &direction_notregular_90_0_0, &direction_notregular_90_0_0, &direction_notregular_90_0_0, NULL, &direction_notregular_90_0_16, &direction_notregular_90_0_16, &direction_notregular_90_0_16, &direction_notregular_90_0_16, &direction_notregular_90_0_16, &direction_notregular_90_0_16, &direction_notregular_90_0_16, &direction_notregular_90_0_16, &direction_notregular_90_0_16, &direction_notregular_90_0_16, &direction_notregular_90_0_16, &direction_notregular_90_0_16, &direction_notregular_90_0_16, &direction_notregular_90_0_16, &direction_notregular_90_0_16, NULL, &direction_notregular_90_0_0, &direction_notregular_90_0_0, &direction_notregular_90_0_0, &direction_notregular_90_0_0, &direction_notregular_90_0_0, &direction_notregular_90_0_0, &direction_notregular_90_0_0};
static Image* images_notregular_90_1_0[4];
static Direction direction_notregular_90_1_0 = {0, 12, 12, 0, -1, 4, images_notregular_90_1_0};
static Image* images_notregular_90_1_16[4];
static Direction direction_notregular_90_1_16 = {16, 12, 12, 0, -1, 4, images_notregular_90_1_16};
static Animation anim_notregular_90_1 = {&direction_notregular_90_1_0, &direction_notregular_90_1_0, &direction_notregular_90_1_0, &direction_notregular_90_1_0, &direction_notregular_90_1_0, &direction_notregular_90_1_0, &direction_notregular_90_1_0, &direction_notregular_90_1_0, NULL, &direction_notregular_90_1_16, &direction_notregular_90_1_16, &direction_notregular_90_1_16, &direction_notregular_90_1_16, &direction_notregular_90_1_16, &direction_notregular_90_1_16, &direction_notregular_90_1_16, &direction_notregular_90_1_16, &direction_notregular_90_1_16, &direction_notregular_90_1_16, &direction_notregular_90_1_16, &direction_notregular_90_1_16, &direction_notregular_90_1_16, &direction_notregular_90_1_16, &direction_notregular_90_1_16, NULL, &direction_notregular_90_1_0, &direction_notregular_90_1_0, &direction_notregular_90_1_0, &direction_notregular_90_1_0, &direction_notregular_90_1_0, &direction_notregular_90_1_0, &direction_notregular_90_1_0};
static Image* images_notregular_90_7_0[1];
static Direction direction_notregular_90_7_0 = {0, 50, 50, 0, 1, 1, images_notregular_90_7_0};
static Image* images_notregular_90_7_16[1];
static Direction direction_notregular_90_7_16 = {16, 50, 50, 0, 1, 1, images_notregular_90_7_16};
static Animation anim_notregular_90_7 = {&direction_notregular_90_7_0, &direction_notregular_90_7_0, &direction_notregular_90_7_0, &direction_notregular_90_7_0, &direction_notregular_90_7_0, &direction_notregular_90_7_0, &direction_notregular_90_7_0, &direction_notregular_90_7_0, NULL, &direction_notregular_90_7_16, &direction_notregular_90_7_16, &direction_notregular_90_7_16, &direction_notregular_90_7_16, &direction_notregular_90_7_16, &direction_notregular_90_7_16, &direction_notregular_90_7_16, &direction_notregular_90_7_16, &direction_notregular_90_7_16, &direction_notregular_90_7_16, &direction_notregular_90_7_16, &direction_notregular_90_7_16, &direction_notregular_90_7_16, &direction_notregular_90_7_16, &direction_notregular_90_7_16, NULL, &direction_notregular_90_7_0, &direction_notregular_90_7_0, &direction_notregular_90_7_0, &direction_notregular_90_7_0, &direction_notregular_90_7_0, &direction_notregular_90_7_0, &direction_notregular_90_7_0};
static Image* images_notregular_90_8_0[2];
static Direction direction_notregular_90_8_0 = {0, 50, 50, 0, -1, 2, images_notregular_90_8_0};
static Image* images_notregular_90_8_16[2];
static Direction direction_notregular_90_8_16 = {16, 50, 50, 0, -1, 2, images_notregular_90_8_16};
static Animation anim_notregular_90_8 = {&direction_notregular_90_8_0, &direction_notregular_90_8_0, &direction_notregular_90_8_0, &direction_notregular_90_8_0, &direction_notregular_90_8_0, &direction_notregular_90_8_0, &direction_notregular_90_8_0, &direction_notregular_90_8_0, NULL, &direction_notregular_90_8_16, &direction_notregular_90_8_16, &direction_notregular_90_8_16, &direction_notregular_90_8_16, &direction_notregular_90_8_16, &direction_notregular_90_8_16, &direction_notregular_90_8_16, &direction_notregular_90_8_16, &direction_notregular_90_8_16, &direction_notregular_90_8_16, &direction_notregular_90_8_16, &direction_notregular_90_8_16, &direction_notregular_90_8_16, &direction_notregular_90_8_16, &direction_notregular_90_8_16, NULL, &direction_notregular_90_8_0, &direction_notregular_90_8_0, &direction_notregular_90_8_0, &direction_notregular_90_8_0, &direction_notregular_90_8_0, &direction_notregular_90_8_0, &direction_notregular_90_8_0};
static Image* images_notregular_90_12_0[19];
static Direction direction_notregular_90_12_0 = {0, 20, 20, 0, 9, 19, images_notregular_90_12_0};
static Animation anim_notregular_90_12 = {&direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, NULL, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0, &direction_notregular_90_12_0};
static Image* images_notregular_90_13_0[10];
static Direction direction_notregular_90_13_0 = {0, 25, 25, 0, 1, 10, images_notregular_90_13_0};
static Animation anim_notregular_90_13 = {&direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, NULL, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0, &direction_notregular_90_13_0};
static Image* images_notregular_90_14_0[2];
static Direction direction_notregular_90_14_0 = {0, 50, 50, 0, 1, 2, images_notregular_90_14_0};
static Animation anim_notregular_90_14 = {&direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, NULL, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0, &direction_notregular_90_14_0};
static Image* images_notregular_90_15_0[2];
static Direction direction_notregular_90_15_0 = {0, 3, 3, 0, 1, 2, images_notregular_90_15_0};
static Image* images_notregular_90_15_16[2];
static Direction direction_notregular_90_15_16 = {16, 3, 3, 0, 1, 2, images_notregular_90_15_16};
static Animation anim_notregular_90_15 = {&direction_notregular_90_15_0, &direction_notregular_90_15_0, &direction_notregular_90_15_0, &direction_notregular_90_15_0, &direction_notregular_90_15_0, &direction_notregular_90_15_0, &direction_notregular_90_15_0, &direction_notregular_90_15_0, NULL, &direction_notregular_90_15_16, &direction_notregular_90_15_16, &direction_notregular_90_15_16, &direction_notregular_90_15_16, &direction_notregular_90_15_16, &direction_notregular_90_15_16, &direction_notregular_90_15_16, &direction_notregular_90_15_16, &direction_notregular_90_15_16, &direction_notregular_90_15_16, &direction_notregular_90_15_16, &direction_notregular_90_15_16, &direction_notregular_90_15_16, &direction_notregular_90_15_16, &direction_notregular_90_15_16, NULL, &direction_notregular_90_15_0, &direction_notregular_90_15_0, &direction_notregular_90_15_0, &direction_notregular_90_15_0, &direction_notregular_90_15_0, &direction_notregular_90_15_0, &direction_notregular_90_15_0};
static Image* images_notregular_90_16_0[4];
static Direction direction_notregular_90_16_0 = {0, 12, 12, 0, -1, 4, images_notregular_90_16_0};
static Image* images_notregular_90_16_16[4];
static Direction direction_notregular_90_16_16 = {16, 12, 12, 0, -1, 4, images_notregular_90_16_16};
static Animation anim_notregular_90_16 = {&direction_notregular_90_16_0, &direction_notregular_90_16_0, &direction_notregular_90_16_0, &direction_notregular_90_16_0, &direction_notregular_90_16_0, &direction_notregular_90_16_0, &direction_notregular_90_16_0, &direction_notregular_90_16_0, NULL, &direction_notregular_90_16_16, &direction_notregular_90_16_16, &direction_notregular_90_16_16, &direction_notregular_90_16_16, &direction_notregular_90_16_16, &direction_notregular_90_16_16, &direction_notregular_90_16_16, &direction_notregular_90_16_16, &direction_notregular_90_16_16, &direction_notregular_90_16_16, &direction_notregular_90_16_16, &direction_notregular_90_16_16, &direction_notregular_90_16_16, &direction_notregular_90_16_16, &direction_notregular_90_16_16, NULL, &direction_notregular_90_16_0, &direction_notregular_90_16_0, &direction_notregular_90_16_0, &direction_notregular_90_16_0, &direction_notregular_90_16_0, &direction_notregular_90_16_0, &direction_notregular_90_16_0};
static Image* images_notregular_90_17_0[1];
static Direction direction_notregular_90_17_0 = {0, 50, 50, 0, 1, 1, images_notregular_90_17_0};
static Image* images_notregular_90_17_16[1];
static Direction direction_notregular_90_17_16 = {16, 50, 50, 0, 1, 1, images_notregular_90_17_16};
static Animation anim_notregular_90_17 = {&direction_notregular_90_17_0, &direction_notregular_90_17_0, &direction_notregular_90_17_0, &direction_notregular_90_17_0, &direction_notregular_90_17_0, &direction_notregular_90_17_0, &direction_notregular_90_17_0, &direction_notregular_90_17_0, NULL, &direction_notregular_90_17_16, &direction_notregular_90_17_16, &direction_notregular_90_17_16, &direction_notregular_90_17_16, &direction_notregular_90_17_16, &direction_notregular_90_17_16, &direction_notregular_90_17_16, &direction_notregular_90_17_16, &direction_notregular_90_17_16, &direction_notregular_90_17_16, &direction_notregular_90_17_16, &direction_notregular_90_17_16, &direction_notregular_90_17_16, &direction_notregular_90_17_16, &direction_notregular_90_17_16, NULL, &direction_notregular_90_17_0, &direction_notregular_90_17_0, &direction_notregular_90_17_0, &direction_notregular_90_17_0, &direction_notregular_90_17_0, &direction_notregular_90_17_0, &direction_notregular_90_17_0};
static Image* images_notregular_90_18_0[2];
static Direction direction_notregular_90_18_0 = {0, 50, 50, 0, -1, 2, images_notregular_90_18_0};
static Image* images_notregular_90_18_16[2];
static Direction direction_notregular_90_18_16 = {16, 50, 50, 0, -1, 2, images_notregular_90_18_16};
static Animation anim_notregular_90_18 = {&direction_notregular_90_18_0, &direction_notregular_90_18_0, &direction_notregular_90_18_0, &direction_notregular_90_18_0, &direction_notregular_90_18_0, &direction_notregular_90_18_0, &direction_notregular_90_18_0, &direction_notregular_90_18_0, NULL, &direction_notregular_90_18_16, &direction_notregular_90_18_16, &direction_notregular_90_18_16, &direction_notregular_90_18_16, &direction_notregular_90_18_16, &direction_notregular_90_18_16, &direction_notregular_90_18_16, &direction_notregular_90_18_16, &direction_notregular_90_18_16, &direction_notregular_90_18_16, &direction_notregular_90_18_16, &direction_notregular_90_18_16, &direction_notregular_90_18_16, &direction_notregular_90_18_16, &direction_notregular_90_18_16, NULL, &direction_notregular_90_18_0, &direction_notregular_90_18_0, &direction_notregular_90_18_0, &direction_notregular_90_18_0, &direction_notregular_90_18_0, &direction_notregular_90_18_0, &direction_notregular_90_18_0};
static Image* images_notregular_90_19_0[1];
static Direction direction_notregular_90_19_0 = {0, 50, 50, 0, 1, 1, images_notregular_90_19_0};
static Image* images_notregular_90_19_16[1];
static Direction direction_notregular_90_19_16 = {16, 50, 50, 0, 1, 1, images_notregular_90_19_16};
static Animation anim_notregular_90_19 = {&direction_notregular_90_19_0, &direction_notregular_90_19_0, &direction_notregular_90_19_0, &direction_notregular_90_19_0, &direction_notregular_90_19_0, &direction_notregular_90_19_0, &direction_notregular_90_19_0, &direction_notregular_90_19_0, NULL, &direction_notregular_90_19_16, &direction_notregular_90_19_16, &direction_notregular_90_19_16, &direction_notregular_90_19_16, &direction_notregular_90_19_16, &direction_notregular_90_19_16, &direction_notregular_90_19_16, &direction_notregular_90_19_16, &direction_notregular_90_19_16, &direction_notregular_90_19_16, &direction_notregular_90_19_16, &direction_notregular_90_19_16, &direction_notregular_90_19_16, &direction_notregular_90_19_16, &direction_notregular_90_19_16, NULL, &direction_notregular_90_19_0, &direction_notregular_90_19_0, &direction_notregular_90_19_0, &direction_notregular_90_19_0, &direction_notregular_90_19_0, &direction_notregular_90_19_0, &direction_notregular_90_19_0};
static Image* images_notregular_90_20_0[1];
static Direction direction_notregular_90_20_0 = {0, 50, 50, 0, 1, 1, images_notregular_90_20_0};
static Image* images_notregular_90_20_16[1];
static Direction direction_notregular_90_20_16 = {16, 50, 50, 0, 1, 1, images_notregular_90_20_16};
static Animation anim_notregular_90_20 = {&direction_notregular_90_20_0, &direction_notregular_90_20_0, &direction_notregular_90_20_0, &direction_notregular_90_20_0, &direction_notregular_90_20_0, &direction_notregular_90_20_0, &direction_notregular_90_20_0, &direction_notregular_90_20_0, NULL, &direction_notregular_90_20_16, &direction_notregular_90_20_16, &direction_notregular_90_20_16, &direction_notregular_90_20_16, &direction_notregular_90_20_16, &direction_notregular_90_20_16, &direction_notregular_90_20_16, &direction_notregular_90_20_16, &direction_notregular_90_20_16, &direction_notregular_90_20_16, &direction_notregular_90_20_16, &direction_notregular_90_20_16, &direction_notregular_90_20_16, &direction_notregular_90_20_16, &direction_notregular_90_20_16, NULL, &direction_notregular_90_20_0, &direction_notregular_90_20_0, &direction_notregular_90_20_0, &direction_notregular_90_20_0, &direction_notregular_90_20_0, &direction_notregular_90_20_0, &direction_notregular_90_20_0};
static Image* images_notregular_90_21_0[2];
static Direction direction_notregular_90_21_0 = {0, 18, 18, 0, 1, 2, images_notregular_90_21_0};
static Image* images_notregular_90_21_16[2];
static Direction direction_notregular_90_21_16 = {16, 18, 18, 0, 3, 2, images_notregular_90_21_16};
static Animation anim_notregular_90_21 = {&direction_notregular_90_21_0, &direction_notregular_90_21_0, &direction_notregular_90_21_0, &direction_notregular_90_21_0, &direction_notregular_90_21_0, &direction_notregular_90_21_0, &direction_notregular_90_21_0, &direction_notregular_90_21_0, NULL, &direction_notregular_90_21_16, &direction_notregular_90_21_16, &direction_notregular_90_21_16, &direction_notregular_90_21_16, &direction_notregular_90_21_16, &direction_notregular_90_21_16, &direction_notregular_90_21_16, &direction_notregular_90_21_16, &direction_notregular_90_21_16, &direction_notregular_90_21_16, &direction_notregular_90_21_16, &direction_notregular_90_21_16, &direction_notregular_90_21_16, &direction_notregular_90_21_16, &direction_notregular_90_21_16, NULL, &direction_notregular_90_21_0, &direction_notregular_90_21_0, &direction_notregular_90_21_0, &direction_notregular_90_21_0, &direction_notregular_90_21_0, &direction_notregular_90_21_0, &direction_notregular_90_21_0};
static Animation * anim_array_notregular_90[22] = {&anim_notregular_90_0, &anim_notregular_90_1, NULL, NULL, NULL, NULL, NULL, &anim_notregular_90_7, &anim_notregular_90_8, NULL, NULL, NULL, &anim_notregular_90_12, &anim_notregular_90_13, &anim_notregular_90_14, &anim_notregular_90_15, &anim_notregular_90_16, &anim_notregular_90_17, &anim_notregular_90_18, &anim_notregular_90_19, &anim_notregular_90_20, &anim_notregular_90_21};
static Animations anim_notregular_90 = {22, &anim_array_notregular_90[0]};
static bool anim_notregular_90_initialized;
class NOTREGULAR_90 : public Active
{
public:
    NOTREGULAR_90(int x, int y) : Active(x, y, NOTREGULAR_90_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("NOT REGULAR", 11);
#endif
        this->animations = &anim_notregular_90;
        if (!anim_notregular_90_initialized) {
            anim_notregular_90_initialized = true;
            images_notregular_90_0_0[0] = get_internal_image_direct(150);
            images_notregular_90_0_16[0] = get_internal_image_direct(159);
            images_notregular_90_1_0[0] = get_internal_image_direct(709);
            images_notregular_90_1_0[1] = get_internal_image_direct(783);
            images_notregular_90_1_0[2] = get_internal_image_direct(649);
            images_notregular_90_1_0[3] = get_internal_image_direct(783);
            images_notregular_90_1_16[0] = get_internal_image_direct(120);
            images_notregular_90_1_16[1] = get_internal_image_direct(121);
            images_notregular_90_1_16[2] = get_internal_image_direct(122);
            images_notregular_90_1_16[3] = get_internal_image_direct(124);
            images_notregular_90_7_0[0] = get_internal_image_direct(165);
            images_notregular_90_7_16[0] = get_internal_image_direct(160);
            images_notregular_90_8_0[0] = get_internal_image_direct(165);
            images_notregular_90_8_0[1] = get_internal_image_direct(166);
            images_notregular_90_8_16[0] = get_internal_image_direct(167);
            images_notregular_90_8_16[1] = get_internal_image_direct(161);
            images_notregular_90_12_0[0] = get_internal_image_direct(55);
            images_notregular_90_12_0[1] = get_internal_image_direct(55);
            images_notregular_90_12_0[2] = get_internal_image_direct(55);
            images_notregular_90_12_0[3] = get_internal_image_direct(55);
            images_notregular_90_12_0[4] = get_internal_image_direct(55);
            images_notregular_90_12_0[5] = get_internal_image_direct(55);
            images_notregular_90_12_0[6] = get_internal_image_direct(55);
            images_notregular_90_12_0[7] = get_internal_image_direct(55);
            images_notregular_90_12_0[8] = get_internal_image_direct(55);
            images_notregular_90_12_0[9] = get_internal_image_direct(55);
            images_notregular_90_12_0[10] = get_internal_image_direct(55);
            images_notregular_90_12_0[11] = get_internal_image_direct(55);
            images_notregular_90_12_0[12] = get_internal_image_direct(55);
            images_notregular_90_12_0[13] = get_internal_image_direct(55);
            images_notregular_90_12_0[14] = get_internal_image_direct(55);
            images_notregular_90_12_0[15] = get_internal_image_direct(55);
            images_notregular_90_12_0[16] = get_internal_image_direct(55);
            images_notregular_90_12_0[17] = get_internal_image_direct(56);
            images_notregular_90_12_0[18] = get_internal_image_direct(55);
            images_notregular_90_13_0[0] = get_internal_image_direct(54);
            images_notregular_90_13_0[1] = get_internal_image_direct(54);
            images_notregular_90_13_0[2] = get_internal_image_direct(54);
            images_notregular_90_13_0[3] = get_internal_image_direct(54);
            images_notregular_90_13_0[4] = get_internal_image_direct(54);
            images_notregular_90_13_0[5] = get_internal_image_direct(54);
            images_notregular_90_13_0[6] = get_internal_image_direct(54);
            images_notregular_90_13_0[7] = get_internal_image_direct(54);
            images_notregular_90_13_0[8] = get_internal_image_direct(54);
            images_notregular_90_13_0[9] = get_internal_image_direct(54);
            images_notregular_90_14_0[0] = get_internal_image_direct(80);
            images_notregular_90_14_0[1] = get_internal_image_direct(105);
            images_notregular_90_15_0[0] = get_internal_image_direct(154);
            images_notregular_90_15_0[1] = get_internal_image_direct(154);
            images_notregular_90_15_16[0] = get_internal_image_direct(163);
            images_notregular_90_15_16[1] = get_internal_image_direct(163);
            images_notregular_90_16_0[0] = get_internal_image_direct(155);
            images_notregular_90_16_0[1] = get_internal_image_direct(156);
            images_notregular_90_16_0[2] = get_internal_image_direct(157);
            images_notregular_90_16_0[3] = get_internal_image_direct(158);
            images_notregular_90_16_16[0] = get_internal_image_direct(123);
            images_notregular_90_16_16[1] = get_internal_image_direct(126);
            images_notregular_90_16_16[2] = get_internal_image_direct(125);
            images_notregular_90_16_16[3] = get_internal_image_direct(127);
            images_notregular_90_17_0[0] = get_internal_image_direct(164);
            images_notregular_90_17_16[0] = get_internal_image_direct(18);
            images_notregular_90_18_0[0] = get_internal_image_direct(168);
            images_notregular_90_18_0[1] = get_internal_image_direct(168);
            images_notregular_90_18_16[0] = get_internal_image_direct(162);
            images_notregular_90_18_16[1] = get_internal_image_direct(162);
            images_notregular_90_19_0[0] = get_internal_image_direct(129);
            images_notregular_90_19_16[0] = get_internal_image_direct(130);
            images_notregular_90_20_0[0] = get_internal_image_direct(128);
            images_notregular_90_20_16[0] = get_internal_image_direct(131);
            images_notregular_90_21_0[0] = get_internal_image_direct(16);
            images_notregular_90_21_0[1] = get_internal_image_direct(76);
            images_notregular_90_21_16[0] = get_internal_image_direct(19);
            images_notregular_90_21_16[1] = get_internal_image_direct(77);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        set_direction(0);
        create_alterables();
    }
};
FrameObject * create_notregular_90(int x, int y)
{
    return new (Active::pool.create()) NOTREGULAR_90(x, y);
}
class String2_91 : public Text
{
public:
    String2_91(int x, int y) : Text(x, y, String2_91_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("String 2", 8);
#endif
        flags &= ~SCROLL;
        width = 26;
        height = 21;
        blend_color = Color(255, 255, 255);
        bold = false;
        italic = false;
        font_name = chowstring("Small Fonts", 11);
        font = get_font(7, 0);
        alignment = ALIGN_LEFT | ALIGN_TOP;
        add_line(chowstring("x  15", 5));
        create_alterables();
    }
};
FrameObject * create_string2_91(int x, int y)
{
    return new (Text::pool.create()) String2_91(x, y);
}
class BgWall_92 : public Backdrop
{
public:
    BgWall_92(int x, int y) : Backdrop(x, y, BACKGROUND_TYPE)
    {
#ifndef NDEBUG
        name = chowstring("bg-wall", 7);
#endif
        flags |= BACKGROUND;
        flags |= BACKGROUND_COL;
#ifdef BACK_ID_BG_WALL
        manager.frame->back_instances[BACK_ID_BG_WALL].push_back(this);
#endif
        image = get_internal_image(1103);
        width = image->width;
        height = image->height;
        collision = new BackdropCollision(this, image);
    }
};
FrameObject * create_bgwall_92(int x, int y)
{
    return new (Backdrop::pool.create()) BgWall_92(x, y);
}
static Image* images_player_93_0_0[1];
static Direction direction_player_93_0_0 = {0, 50, 50, 0, 1, 1, images_player_93_0_0};
static Animation anim_player_93_0 = {&direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, NULL, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0, &direction_player_93_0_0};
static Animation * anim_array_player_93[1] = {&anim_player_93_0};
static Animations anim_player_93 = {1, &anim_array_player_93[0]};
static bool anim_player_93_initialized;
class Player_93 : public Active
{
public:
    Player_93(int x, int y) : Active(x, y, Player_93_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Player", 6);
#endif
        set_visible(false);
        this->animations = &anim_player_93;
        if (!anim_player_93_initialized) {
            anim_player_93_initialized = true;
            images_player_93_0_0[0] = get_internal_image_direct(1109);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
        alterables->values.set(13, 1);
        alterables->values.set(15, 1);
    }
};
FrameObject * create_player_93(int x, int y)
{
    return new (Active::pool.create()) Player_93(x, y);
}
static Image* images_detector_94_0_0[1];
static Direction direction_detector_94_0_0 = {0, 50, 50, 0, 1, 1, images_detector_94_0_0};
static Animation anim_detector_94_0 = {&direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, NULL, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0, &direction_detector_94_0_0};
static Animation * anim_array_detector_94[1] = {&anim_detector_94_0};
static Animations anim_detector_94 = {1, &anim_array_detector_94[0]};
static bool anim_detector_94_initialized;
class Detector_94 : public Active
{
public:
    Detector_94(int x, int y) : Active(x, y, Detector_94_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Detector", 8);
#endif
        set_visible(false);
        this->animations = &anim_detector_94;
        if (!anim_detector_94_initialized) {
            anim_detector_94_initialized = true;
            images_detector_94_0_0[0] = get_internal_image_direct(6);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        create_alterables();
    }
};
FrameObject * create_detector_94(int x, int y)
{
    return new (Active::pool.create()) Detector_94(x, y);
}
static Image* images_platform_95_0_0[1];
static Direction direction_platform_95_0_0 = {0, 50, 50, 0, 1, 1, images_platform_95_0_0};
static Image* images_platform_95_0_16[1];
static Direction direction_platform_95_0_16 = {16, 50, 50, 0, 1, 1, images_platform_95_0_16};
static Animation anim_platform_95_0 = {&direction_platform_95_0_0, &direction_platform_95_0_0, &direction_platform_95_0_0, &direction_platform_95_0_0, &direction_platform_95_0_0, &direction_platform_95_0_0, &direction_platform_95_0_0, &direction_platform_95_0_0, NULL, &direction_platform_95_0_16, &direction_platform_95_0_16, &direction_platform_95_0_16, &direction_platform_95_0_16, &direction_platform_95_0_16, &direction_platform_95_0_16, &direction_platform_95_0_16, &direction_platform_95_0_16, &direction_platform_95_0_16, &direction_platform_95_0_16, &direction_platform_95_0_16, &direction_platform_95_0_16, &direction_platform_95_0_16, &direction_platform_95_0_16, &direction_platform_95_0_16, NULL, &direction_platform_95_0_0, &direction_platform_95_0_0, &direction_platform_95_0_0, &direction_platform_95_0_0, &direction_platform_95_0_0, &direction_platform_95_0_0, &direction_platform_95_0_0};
static Animation * anim_array_platform_95[1] = {&anim_platform_95_0};
static Animations anim_platform_95 = {1, &anim_array_platform_95[0]};
static bool anim_platform_95_initialized;
class Platform_95 : public Active
{
public:
    Platform_95(int x, int y) : Active(x, y, Platform_95_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Platform", 8);
#endif
        set_visible(false);
        this->animations = &anim_platform_95;
        if (!anim_platform_95_initialized) {
            anim_platform_95_initialized = true;
            images_platform_95_0_0[0] = get_internal_image_direct(11);
            images_platform_95_0_16[0] = get_internal_image_direct(10);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        set_direction(16);
        create_alterables();
    }
};
FrameObject * create_platform_95(int x, int y)
{
    return new (Active::pool.create()) Platform_95(x, y);
}
class BgOneway_96 : public Backdrop
{
public:
    BgOneway_96(int x, int y) : Backdrop(x, y, BACKGROUND_TYPE)
    {
#ifndef NDEBUG
        name = chowstring("bg-oneway", 9);
#endif
        flags |= BACKGROUND;
        flags |= BACKGROUND_COL;
#ifdef BACK_ID_BG_ONEWAY
        manager.frame->back_instances[BACK_ID_BG_ONEWAY].push_back(this);
#endif
        image = get_internal_image(17);
        width = image->width;
        height = image->height;
    }
};
FrameObject * create_bgoneway_96(int x, int y)
{
    return new (Backdrop::pool.create()) BgOneway_96(x, y);
}
static Image* images_movingplatform_97_0_0[2];
static Direction direction_movingplatform_97_0_0 = {0, 50, 50, 0, -1, 2, images_movingplatform_97_0_0};
static Animation anim_movingplatform_97_0 = {&direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, NULL, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0, &direction_movingplatform_97_0_0};
static Image* images_movingplatform_97_3_0[30];
static Direction direction_movingplatform_97_3_0 = {0, 50, 50, 0, 1, 30, images_movingplatform_97_3_0};
static Animation anim_movingplatform_97_3 = {&direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, NULL, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0, &direction_movingplatform_97_3_0};
static Animation * anim_array_movingplatform_97[4] = {&anim_movingplatform_97_0, NULL, NULL, &anim_movingplatform_97_3};
static Animations anim_movingplatform_97 = {4, &anim_array_movingplatform_97[0]};
static bool anim_movingplatform_97_initialized;
class MovingPlatform_97 : public Active
{
public:
    MovingPlatform_97(int x, int y) : Active(x, y, MovingPlatform_97_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Moving Platform", 15);
#endif
        this->animations = &anim_movingplatform_97;
        if (!anim_movingplatform_97_initialized) {
            anim_movingplatform_97_initialized = true;
            images_movingplatform_97_0_0[0] = get_internal_image_direct(354);
            images_movingplatform_97_0_0[1] = get_internal_image_direct(376);
            images_movingplatform_97_3_0[0] = get_internal_image_direct(487);
            images_movingplatform_97_3_0[1] = get_internal_image_direct(473);
            images_movingplatform_97_3_0[2] = get_internal_image_direct(488);
            images_movingplatform_97_3_0[3] = get_internal_image_direct(491);
            images_movingplatform_97_3_0[4] = get_internal_image_direct(494);
            images_movingplatform_97_3_0[5] = get_internal_image_direct(495);
            images_movingplatform_97_3_0[6] = get_internal_image_direct(499);
            images_movingplatform_97_3_0[7] = get_internal_image_direct(500);
            images_movingplatform_97_3_0[8] = get_internal_image_direct(501);
            images_movingplatform_97_3_0[9] = get_internal_image_direct(508);
            images_movingplatform_97_3_0[10] = get_internal_image_direct(506);
            images_movingplatform_97_3_0[11] = get_internal_image_direct(509);
            images_movingplatform_97_3_0[12] = get_internal_image_direct(510);
            images_movingplatform_97_3_0[13] = get_internal_image_direct(507);
            images_movingplatform_97_3_0[14] = get_internal_image_direct(511);
            images_movingplatform_97_3_0[15] = get_internal_image_direct(513);
            images_movingplatform_97_3_0[16] = get_internal_image_direct(512);
            images_movingplatform_97_3_0[17] = get_internal_image_direct(514);
            images_movingplatform_97_3_0[18] = get_internal_image_direct(516);
            images_movingplatform_97_3_0[19] = get_internal_image_direct(517);
            images_movingplatform_97_3_0[20] = get_internal_image_direct(515);
            images_movingplatform_97_3_0[21] = get_internal_image_direct(518);
            images_movingplatform_97_3_0[22] = get_internal_image_direct(520);
            images_movingplatform_97_3_0[23] = get_internal_image_direct(519);
            images_movingplatform_97_3_0[24] = get_internal_image_direct(522);
            images_movingplatform_97_3_0[25] = get_internal_image_direct(524);
            images_movingplatform_97_3_0[26] = get_internal_image_direct(525);
            images_movingplatform_97_3_0[27] = get_internal_image_direct(526);
            images_movingplatform_97_3_0[28] = get_internal_image_direct(527);
            images_movingplatform_97_3_0[29] = get_internal_image_direct(376);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        forced_animation = current_animation = APPEARING;
        initialize_active(false);
        create_alterables();
        alterables->values.set(0, 2);
    }
};
FrameObject * create_movingplatform_97(int x, int y)
{
    return new (Active::pool.create()) MovingPlatform_97(x, y);
}
static Image* images_platform2_98_0_0[1];
static Direction direction_platform2_98_0_0 = {0, 50, 50, 0, 1, 1, images_platform2_98_0_0};
static Image* images_platform2_98_0_16[1];
static Direction direction_platform2_98_0_16 = {16, 50, 50, 0, 1, 1, images_platform2_98_0_16};
static Animation anim_platform2_98_0 = {&direction_platform2_98_0_0, &direction_platform2_98_0_0, &direction_platform2_98_0_0, &direction_platform2_98_0_0, &direction_platform2_98_0_0, &direction_platform2_98_0_0, &direction_platform2_98_0_0, &direction_platform2_98_0_0, NULL, &direction_platform2_98_0_16, &direction_platform2_98_0_16, &direction_platform2_98_0_16, &direction_platform2_98_0_16, &direction_platform2_98_0_16, &direction_platform2_98_0_16, &direction_platform2_98_0_16, &direction_platform2_98_0_16, &direction_platform2_98_0_16, &direction_platform2_98_0_16, &direction_platform2_98_0_16, &direction_platform2_98_0_16, &direction_platform2_98_0_16, &direction_platform2_98_0_16, &direction_platform2_98_0_16, NULL, &direction_platform2_98_0_0, &direction_platform2_98_0_0, &direction_platform2_98_0_0, &direction_platform2_98_0_0, &direction_platform2_98_0_0, &direction_platform2_98_0_0, &direction_platform2_98_0_0};
static Animation * anim_array_platform2_98[1] = {&anim_platform2_98_0};
static Animations anim_platform2_98 = {1, &anim_array_platform2_98[0]};
static bool anim_platform2_98_initialized;
class Platform2_98 : public Active
{
public:
    Platform2_98(int x, int y) : Active(x, y, Platform2_98_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Platform 2", 10);
#endif
        set_visible(false);
        this->animations = &anim_platform2_98;
        if (!anim_platform2_98_initialized) {
            anim_platform2_98_initialized = true;
            images_platform2_98_0_0[0] = get_internal_image_direct(14);
            images_platform2_98_0_16[0] = get_internal_image_direct(10);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        set_direction(16);
        create_alterables();
    }
};
FrameObject * create_platform2_98(int x, int y)
{
    return new (Active::pool.create()) Platform2_98(x, y);
}
static Image* images_sprite_99_0_0[6];
static Direction direction_sprite_99_0_0 = {0, 10, 10, 0, -1, 6, images_sprite_99_0_0};
static Image* images_sprite_99_0_16[6];
static Direction direction_sprite_99_0_16 = {16, 8, 8, 0, -1, 6, images_sprite_99_0_16};
static Animation anim_sprite_99_0 = {&direction_sprite_99_0_0, &direction_sprite_99_0_0, &direction_sprite_99_0_0, &direction_sprite_99_0_0, &direction_sprite_99_0_0, &direction_sprite_99_0_0, &direction_sprite_99_0_0, &direction_sprite_99_0_0, NULL, &direction_sprite_99_0_16, &direction_sprite_99_0_16, &direction_sprite_99_0_16, &direction_sprite_99_0_16, &direction_sprite_99_0_16, &direction_sprite_99_0_16, &direction_sprite_99_0_16, &direction_sprite_99_0_16, &direction_sprite_99_0_16, &direction_sprite_99_0_16, &direction_sprite_99_0_16, &direction_sprite_99_0_16, &direction_sprite_99_0_16, &direction_sprite_99_0_16, &direction_sprite_99_0_16, NULL, &direction_sprite_99_0_0, &direction_sprite_99_0_0, &direction_sprite_99_0_0, &direction_sprite_99_0_0, &direction_sprite_99_0_0, &direction_sprite_99_0_0, &direction_sprite_99_0_0};
static Image* images_sprite_99_1_0[4];
static Direction direction_sprite_99_1_0 = {0, 12, 12, 0, -1, 4, images_sprite_99_1_0};
static Image* images_sprite_99_1_16[4];
static Direction direction_sprite_99_1_16 = {16, 12, 12, 0, -1, 4, images_sprite_99_1_16};
static Animation anim_sprite_99_1 = {&direction_sprite_99_1_0, &direction_sprite_99_1_0, &direction_sprite_99_1_0, &direction_sprite_99_1_0, &direction_sprite_99_1_0, &direction_sprite_99_1_0, &direction_sprite_99_1_0, &direction_sprite_99_1_0, NULL, &direction_sprite_99_1_16, &direction_sprite_99_1_16, &direction_sprite_99_1_16, &direction_sprite_99_1_16, &direction_sprite_99_1_16, &direction_sprite_99_1_16, &direction_sprite_99_1_16, &direction_sprite_99_1_16, &direction_sprite_99_1_16, &direction_sprite_99_1_16, &direction_sprite_99_1_16, &direction_sprite_99_1_16, &direction_sprite_99_1_16, &direction_sprite_99_1_16, &direction_sprite_99_1_16, NULL, &direction_sprite_99_1_0, &direction_sprite_99_1_0, &direction_sprite_99_1_0, &direction_sprite_99_1_0, &direction_sprite_99_1_0, &direction_sprite_99_1_0, &direction_sprite_99_1_0};
static Image* images_sprite_99_2_0[4];
static Direction direction_sprite_99_2_0 = {0, 50, 50, 0, -1, 4, images_sprite_99_2_0};
static Animation anim_sprite_99_2 = {&direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, NULL, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0, &direction_sprite_99_2_0};
static Image* images_sprite_99_5_0[4];
static Direction direction_sprite_99_5_0 = {0, 50, 50, 0, -1, 4, images_sprite_99_5_0};
static Animation anim_sprite_99_5 = {&direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, NULL, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0, &direction_sprite_99_5_0};
static Image* images_sprite_99_7_0[2];
static Direction direction_sprite_99_7_0 = {0, 10, 10, 1, -1, 2, images_sprite_99_7_0};
static Image* images_sprite_99_7_16[2];
static Direction direction_sprite_99_7_16 = {16, 10, 10, 1, -1, 2, images_sprite_99_7_16};
static Animation anim_sprite_99_7 = {&direction_sprite_99_7_0, &direction_sprite_99_7_0, &direction_sprite_99_7_0, &direction_sprite_99_7_0, &direction_sprite_99_7_0, &direction_sprite_99_7_0, &direction_sprite_99_7_0, &direction_sprite_99_7_0, NULL, &direction_sprite_99_7_16, &direction_sprite_99_7_16, &direction_sprite_99_7_16, &direction_sprite_99_7_16, &direction_sprite_99_7_16, &direction_sprite_99_7_16, &direction_sprite_99_7_16, &direction_sprite_99_7_16, &direction_sprite_99_7_16, &direction_sprite_99_7_16, &direction_sprite_99_7_16, &direction_sprite_99_7_16, &direction_sprite_99_7_16, &direction_sprite_99_7_16, &direction_sprite_99_7_16, NULL, &direction_sprite_99_7_0, &direction_sprite_99_7_0, &direction_sprite_99_7_0, &direction_sprite_99_7_0, &direction_sprite_99_7_0, &direction_sprite_99_7_0, &direction_sprite_99_7_0};
static Image* images_sprite_99_8_0[2];
static Direction direction_sprite_99_8_0 = {0, 12, 12, 1, -1, 2, images_sprite_99_8_0};
static Image* images_sprite_99_8_16[2];
static Direction direction_sprite_99_8_16 = {16, 12, 12, 1, -1, 2, images_sprite_99_8_16};
static Animation anim_sprite_99_8 = {&direction_sprite_99_8_0, &direction_sprite_99_8_0, &direction_sprite_99_8_0, &direction_sprite_99_8_0, &direction_sprite_99_8_0, &direction_sprite_99_8_0, &direction_sprite_99_8_0, &direction_sprite_99_8_0, NULL, &direction_sprite_99_8_16, &direction_sprite_99_8_16, &direction_sprite_99_8_16, &direction_sprite_99_8_16, &direction_sprite_99_8_16, &direction_sprite_99_8_16, &direction_sprite_99_8_16, &direction_sprite_99_8_16, &direction_sprite_99_8_16, &direction_sprite_99_8_16, &direction_sprite_99_8_16, &direction_sprite_99_8_16, &direction_sprite_99_8_16, &direction_sprite_99_8_16, &direction_sprite_99_8_16, NULL, &direction_sprite_99_8_0, &direction_sprite_99_8_0, &direction_sprite_99_8_0, &direction_sprite_99_8_0, &direction_sprite_99_8_0, &direction_sprite_99_8_0, &direction_sprite_99_8_0};
static Image* images_sprite_99_12_0[19];
static Direction direction_sprite_99_12_0 = {0, 20, 20, 0, 9, 19, images_sprite_99_12_0};
static Animation anim_sprite_99_12 = {&direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, NULL, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0, &direction_sprite_99_12_0};
static Image* images_sprite_99_13_0[10];
static Direction direction_sprite_99_13_0 = {0, 25, 25, 0, 1, 10, images_sprite_99_13_0};
static Animation anim_sprite_99_13 = {&direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, NULL, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0, &direction_sprite_99_13_0};
static Image* images_sprite_99_14_0[3];
static Direction direction_sprite_99_14_0 = {0, 50, 50, 0, 1, 3, images_sprite_99_14_0};
static Animation anim_sprite_99_14 = {&direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, NULL, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0, &direction_sprite_99_14_0};
static Image* images_sprite_99_15_0[3];
static Direction direction_sprite_99_15_0 = {0, 20, 20, 2, -1, 3, images_sprite_99_15_0};
static Image* images_sprite_99_15_16[3];
static Direction direction_sprite_99_15_16 = {16, 20, 20, 2, -1, 3, images_sprite_99_15_16};
static Animation anim_sprite_99_15 = {&direction_sprite_99_15_0, &direction_sprite_99_15_0, &direction_sprite_99_15_0, &direction_sprite_99_15_0, &direction_sprite_99_15_0, &direction_sprite_99_15_0, &direction_sprite_99_15_0, &direction_sprite_99_15_0, NULL, &direction_sprite_99_15_16, &direction_sprite_99_15_16, &direction_sprite_99_15_16, &direction_sprite_99_15_16, &direction_sprite_99_15_16, &direction_sprite_99_15_16, &direction_sprite_99_15_16, &direction_sprite_99_15_16, &direction_sprite_99_15_16, &direction_sprite_99_15_16, &direction_sprite_99_15_16, &direction_sprite_99_15_16, &direction_sprite_99_15_16, &direction_sprite_99_15_16, &direction_sprite_99_15_16, NULL, &direction_sprite_99_15_0, &direction_sprite_99_15_0, &direction_sprite_99_15_0, &direction_sprite_99_15_0, &direction_sprite_99_15_0, &direction_sprite_99_15_0, &direction_sprite_99_15_0};
static Image* images_sprite_99_16_0[4];
static Direction direction_sprite_99_16_0 = {0, 12, 12, 0, -1, 4, images_sprite_99_16_0};
static Image* images_sprite_99_16_16[4];
static Direction direction_sprite_99_16_16 = {16, 12, 12, 0, -1, 4, images_sprite_99_16_16};
static Animation anim_sprite_99_16 = {&direction_sprite_99_16_0, &direction_sprite_99_16_0, &direction_sprite_99_16_0, &direction_sprite_99_16_0, &direction_sprite_99_16_0, &direction_sprite_99_16_0, &direction_sprite_99_16_0, &direction_sprite_99_16_0, NULL, &direction_sprite_99_16_16, &direction_sprite_99_16_16, &direction_sprite_99_16_16, &direction_sprite_99_16_16, &direction_sprite_99_16_16, &direction_sprite_99_16_16, &direction_sprite_99_16_16, &direction_sprite_99_16_16, &direction_sprite_99_16_16, &direction_sprite_99_16_16, &direction_sprite_99_16_16, &direction_sprite_99_16_16, &direction_sprite_99_16_16, &direction_sprite_99_16_16, &direction_sprite_99_16_16, NULL, &direction_sprite_99_16_0, &direction_sprite_99_16_0, &direction_sprite_99_16_0, &direction_sprite_99_16_0, &direction_sprite_99_16_0, &direction_sprite_99_16_0, &direction_sprite_99_16_0};
static Image* images_sprite_99_17_0[1];
static Direction direction_sprite_99_17_0 = {0, 50, 50, 0, 1, 1, images_sprite_99_17_0};
static Image* images_sprite_99_17_16[1];
static Direction direction_sprite_99_17_16 = {16, 50, 50, 0, 1, 1, images_sprite_99_17_16};
static Animation anim_sprite_99_17 = {&direction_sprite_99_17_0, &direction_sprite_99_17_0, &direction_sprite_99_17_0, &direction_sprite_99_17_0, &direction_sprite_99_17_0, &direction_sprite_99_17_0, &direction_sprite_99_17_0, &direction_sprite_99_17_0, NULL, &direction_sprite_99_17_16, &direction_sprite_99_17_16, &direction_sprite_99_17_16, &direction_sprite_99_17_16, &direction_sprite_99_17_16, &direction_sprite_99_17_16, &direction_sprite_99_17_16, &direction_sprite_99_17_16, &direction_sprite_99_17_16, &direction_sprite_99_17_16, &direction_sprite_99_17_16, &direction_sprite_99_17_16, &direction_sprite_99_17_16, &direction_sprite_99_17_16, &direction_sprite_99_17_16, NULL, &direction_sprite_99_17_0, &direction_sprite_99_17_0, &direction_sprite_99_17_0, &direction_sprite_99_17_0, &direction_sprite_99_17_0, &direction_sprite_99_17_0, &direction_sprite_99_17_0};
static Image* images_sprite_99_18_0[1];
static Direction direction_sprite_99_18_0 = {0, 22, 22, 0, -1, 1, images_sprite_99_18_0};
static Image* images_sprite_99_18_16[1];
static Direction direction_sprite_99_18_16 = {16, 2, 22, 0, -1, 1, images_sprite_99_18_16};
static Animation anim_sprite_99_18 = {&direction_sprite_99_18_0, &direction_sprite_99_18_0, &direction_sprite_99_18_0, &direction_sprite_99_18_0, &direction_sprite_99_18_0, &direction_sprite_99_18_0, &direction_sprite_99_18_0, &direction_sprite_99_18_0, NULL, &direction_sprite_99_18_16, &direction_sprite_99_18_16, &direction_sprite_99_18_16, &direction_sprite_99_18_16, &direction_sprite_99_18_16, &direction_sprite_99_18_16, &direction_sprite_99_18_16, &direction_sprite_99_18_16, &direction_sprite_99_18_16, &direction_sprite_99_18_16, &direction_sprite_99_18_16, &direction_sprite_99_18_16, &direction_sprite_99_18_16, &direction_sprite_99_18_16, &direction_sprite_99_18_16, NULL, &direction_sprite_99_18_0, &direction_sprite_99_18_0, &direction_sprite_99_18_0, &direction_sprite_99_18_0, &direction_sprite_99_18_0, &direction_sprite_99_18_0, &direction_sprite_99_18_0};
static Image* images_sprite_99_19_0[1];
static Direction direction_sprite_99_19_0 = {0, 50, 50, 0, 1, 1, images_sprite_99_19_0};
static Image* images_sprite_99_19_16[1];
static Direction direction_sprite_99_19_16 = {16, 50, 50, 0, 1, 1, images_sprite_99_19_16};
static Animation anim_sprite_99_19 = {&direction_sprite_99_19_0, &direction_sprite_99_19_0, &direction_sprite_99_19_0, &direction_sprite_99_19_0, &direction_sprite_99_19_0, &direction_sprite_99_19_0, &direction_sprite_99_19_0, &direction_sprite_99_19_0, NULL, &direction_sprite_99_19_16, &direction_sprite_99_19_16, &direction_sprite_99_19_16, &direction_sprite_99_19_16, &direction_sprite_99_19_16, &direction_sprite_99_19_16, &direction_sprite_99_19_16, &direction_sprite_99_19_16, &direction_sprite_99_19_16, &direction_sprite_99_19_16, &direction_sprite_99_19_16, &direction_sprite_99_19_16, &direction_sprite_99_19_16, &direction_sprite_99_19_16, &direction_sprite_99_19_16, NULL, &direction_sprite_99_19_0, &direction_sprite_99_19_0, &direction_sprite_99_19_0, &direction_sprite_99_19_0, &direction_sprite_99_19_0, &direction_sprite_99_19_0, &direction_sprite_99_19_0};
static Image* images_sprite_99_20_0[1];
static Direction direction_sprite_99_20_0 = {0, 50, 50, 0, 1, 1, images_sprite_99_20_0};
static Image* images_sprite_99_20_16[1];
static Direction direction_sprite_99_20_16 = {16, 50, 50, 0, 1, 1, images_sprite_99_20_16};
static Animation anim_sprite_99_20 = {&direction_sprite_99_20_0, &direction_sprite_99_20_0, &direction_sprite_99_20_0, &direction_sprite_99_20_0, &direction_sprite_99_20_0, &direction_sprite_99_20_0, &direction_sprite_99_20_0, &direction_sprite_99_20_0, NULL, &direction_sprite_99_20_16, &direction_sprite_99_20_16, &direction_sprite_99_20_16, &direction_sprite_99_20_16, &direction_sprite_99_20_16, &direction_sprite_99_20_16, &direction_sprite_99_20_16, &direction_sprite_99_20_16, &direction_sprite_99_20_16, &direction_sprite_99_20_16, &direction_sprite_99_20_16, &direction_sprite_99_20_16, &direction_sprite_99_20_16, &direction_sprite_99_20_16, &direction_sprite_99_20_16, NULL, &direction_sprite_99_20_0, &direction_sprite_99_20_0, &direction_sprite_99_20_0, &direction_sprite_99_20_0, &direction_sprite_99_20_0, &direction_sprite_99_20_0, &direction_sprite_99_20_0};
static Image* images_sprite_99_21_0[4];
static Direction direction_sprite_99_21_0 = {0, 36, 36, 0, 2, 4, images_sprite_99_21_0};
static Image* images_sprite_99_21_16[4];
static Direction direction_sprite_99_21_16 = {16, 36, 36, 0, 3, 4, images_sprite_99_21_16};
static Animation anim_sprite_99_21 = {&direction_sprite_99_21_0, &direction_sprite_99_21_0, &direction_sprite_99_21_0, &direction_sprite_99_21_0, &direction_sprite_99_21_0, &direction_sprite_99_21_0, &direction_sprite_99_21_0, &direction_sprite_99_21_0, NULL, &direction_sprite_99_21_16, &direction_sprite_99_21_16, &direction_sprite_99_21_16, &direction_sprite_99_21_16, &direction_sprite_99_21_16, &direction_sprite_99_21_16, &direction_sprite_99_21_16, &direction_sprite_99_21_16, &direction_sprite_99_21_16, &direction_sprite_99_21_16, &direction_sprite_99_21_16, &direction_sprite_99_21_16, &direction_sprite_99_21_16, &direction_sprite_99_21_16, &direction_sprite_99_21_16, NULL, &direction_sprite_99_21_0, &direction_sprite_99_21_0, &direction_sprite_99_21_0, &direction_sprite_99_21_0, &direction_sprite_99_21_0, &direction_sprite_99_21_0, &direction_sprite_99_21_0};
static Image* images_sprite_99_22_0[6];
static Direction direction_sprite_99_22_0 = {0, 15, 15, 0, 1, 6, images_sprite_99_22_0};
static Image* images_sprite_99_22_16[6];
static Direction direction_sprite_99_22_16 = {16, 15, 15, 0, 1, 6, images_sprite_99_22_16};
static Animation anim_sprite_99_22 = {&direction_sprite_99_22_0, &direction_sprite_99_22_0, &direction_sprite_99_22_0, &direction_sprite_99_22_0, &direction_sprite_99_22_0, &direction_sprite_99_22_0, &direction_sprite_99_22_0, &direction_sprite_99_22_0, NULL, &direction_sprite_99_22_16, &direction_sprite_99_22_16, &direction_sprite_99_22_16, &direction_sprite_99_22_16, &direction_sprite_99_22_16, &direction_sprite_99_22_16, &direction_sprite_99_22_16, &direction_sprite_99_22_16, &direction_sprite_99_22_16, &direction_sprite_99_22_16, &direction_sprite_99_22_16, &direction_sprite_99_22_16, &direction_sprite_99_22_16, &direction_sprite_99_22_16, &direction_sprite_99_22_16, NULL, &direction_sprite_99_22_0, &direction_sprite_99_22_0, &direction_sprite_99_22_0, &direction_sprite_99_22_0, &direction_sprite_99_22_0, &direction_sprite_99_22_0, &direction_sprite_99_22_0};
static Image* images_sprite_99_23_0[1];
static Direction direction_sprite_99_23_0 = {0, 50, 50, 0, 1, 1, images_sprite_99_23_0};
static Image* images_sprite_99_23_16[1];
static Direction direction_sprite_99_23_16 = {16, 50, 50, 0, 1, 1, images_sprite_99_23_16};
static Animation anim_sprite_99_23 = {&direction_sprite_99_23_0, &direction_sprite_99_23_0, &direction_sprite_99_23_0, &direction_sprite_99_23_0, &direction_sprite_99_23_0, &direction_sprite_99_23_0, &direction_sprite_99_23_0, &direction_sprite_99_23_0, NULL, &direction_sprite_99_23_16, &direction_sprite_99_23_16, &direction_sprite_99_23_16, &direction_sprite_99_23_16, &direction_sprite_99_23_16, &direction_sprite_99_23_16, &direction_sprite_99_23_16, &direction_sprite_99_23_16, &direction_sprite_99_23_16, &direction_sprite_99_23_16, &direction_sprite_99_23_16, &direction_sprite_99_23_16, &direction_sprite_99_23_16, &direction_sprite_99_23_16, &direction_sprite_99_23_16, NULL, &direction_sprite_99_23_0, &direction_sprite_99_23_0, &direction_sprite_99_23_0, &direction_sprite_99_23_0, &direction_sprite_99_23_0, &direction_sprite_99_23_0, &direction_sprite_99_23_0};
static Animation * anim_array_sprite_99[24] = {&anim_sprite_99_0, &anim_sprite_99_1, &anim_sprite_99_2, NULL, NULL, &anim_sprite_99_5, NULL, &anim_sprite_99_7, &anim_sprite_99_8, NULL, NULL, NULL, &anim_sprite_99_12, &anim_sprite_99_13, &anim_sprite_99_14, &anim_sprite_99_15, &anim_sprite_99_16, &anim_sprite_99_17, &anim_sprite_99_18, &anim_sprite_99_19, &anim_sprite_99_20, &anim_sprite_99_21, &anim_sprite_99_22, &anim_sprite_99_23};
static Animations anim_sprite_99 = {24, &anim_array_sprite_99[0]};
static bool anim_sprite_99_initialized;
class Sprite_99 : public Active
{
public:
    Sprite_99(int x, int y) : Active(x, y, Sprite_99_type)
    {
        // qualifiers: 
#ifndef NDEBUG
        name = chowstring("Sprite", 6);
#endif
        this->animations = &anim_sprite_99;
        if (!anim_sprite_99_initialized) {
            anim_sprite_99_initialized = true;
            images_sprite_99_0_0[0] = get_internal_image_direct(645);
            images_sprite_99_0_0[1] = get_internal_image_direct(654);
            images_sprite_99_0_0[2] = get_internal_image_direct(658);
            images_sprite_99_0_0[3] = get_internal_image_direct(714);
            images_sprite_99_0_0[4] = get_internal_image_direct(640);
            images_sprite_99_0_0[5] = get_internal_image_direct(644);
            images_sprite_99_0_16[0] = get_internal_image_direct(802);
            images_sprite_99_0_16[1] = get_internal_image_direct(803);
            images_sprite_99_0_16[2] = get_internal_image_direct(804);
            images_sprite_99_0_16[3] = get_internal_image_direct(805);
            images_sprite_99_0_16[4] = get_internal_image_direct(806);
            images_sprite_99_0_16[5] = get_internal_image_direct(807);
            images_sprite_99_1_0[0] = get_internal_image_direct(709);
            images_sprite_99_1_0[1] = get_internal_image_direct(783);
            images_sprite_99_1_0[2] = get_internal_image_direct(649);
            images_sprite_99_1_0[3] = get_internal_image_direct(783);
            images_sprite_99_1_16[0] = get_internal_image_direct(808);
            images_sprite_99_1_16[1] = get_internal_image_direct(809);
            images_sprite_99_1_16[2] = get_internal_image_direct(810);
            images_sprite_99_1_16[3] = get_internal_image_direct(809);
            images_sprite_99_2_0[0] = get_internal_image_direct(635);
            images_sprite_99_2_0[1] = get_internal_image_direct(636);
            images_sprite_99_2_0[2] = get_internal_image_direct(633);
            images_sprite_99_2_0[3] = get_internal_image_direct(637);
            images_sprite_99_5_0[0] = get_internal_image_direct(638);
            images_sprite_99_5_0[1] = get_internal_image_direct(663);
            images_sprite_99_5_0[2] = get_internal_image_direct(671);
            images_sprite_99_5_0[3] = get_internal_image_direct(663);
            images_sprite_99_7_0[0] = get_internal_image_direct(691);
            images_sprite_99_7_0[1] = get_internal_image_direct(694);
            images_sprite_99_7_16[0] = get_internal_image_direct(811);
            images_sprite_99_7_16[1] = get_internal_image_direct(812);
            images_sprite_99_8_0[0] = get_internal_image_direct(691);
            images_sprite_99_8_0[1] = get_internal_image_direct(695);
            images_sprite_99_8_16[0] = get_internal_image_direct(811);
            images_sprite_99_8_16[1] = get_internal_image_direct(813);
            images_sprite_99_12_0[0] = get_internal_image_direct(55);
            images_sprite_99_12_0[1] = get_internal_image_direct(55);
            images_sprite_99_12_0[2] = get_internal_image_direct(55);
            images_sprite_99_12_0[3] = get_internal_image_direct(55);
            images_sprite_99_12_0[4] = get_internal_image_direct(55);
            images_sprite_99_12_0[5] = get_internal_image_direct(55);
            images_sprite_99_12_0[6] = get_internal_image_direct(55);
            images_sprite_99_12_0[7] = get_internal_image_direct(55);
            images_sprite_99_12_0[8] = get_internal_image_direct(55);
            images_sprite_99_12_0[9] = get_internal_image_direct(55);
            images_sprite_99_12_0[10] = get_internal_image_direct(55);
            images_sprite_99_12_0[11] = get_internal_image_direct(55);
            images_sprite_99_12_0[12] = get_internal_image_direct(55);
            images_sprite_99_12_0[13] = get_internal_image_direct(55);
            images_sprite_99_12_0[14] = get_internal_image_direct(55);
            images_sprite_99_12_0[15] = get_internal_image_direct(55);
            images_sprite_99_12_0[16] = get_internal_image_direct(55);
            images_sprite_99_12_0[17] = get_internal_image_direct(56);
            images_sprite_99_12_0[18] = get_internal_image_direct(55);
            images_sprite_99_13_0[0] = get_internal_image_direct(54);
            images_sprite_99_13_0[1] = get_internal_image_direct(54);
            images_sprite_99_13_0[2] = get_internal_image_direct(54);
            images_sprite_99_13_0[3] = get_internal_image_direct(54);
            images_sprite_99_13_0[4] = get_internal_image_direct(54);
            images_sprite_99_13_0[5] = get_internal_image_direct(54);
            images_sprite_99_13_0[6] = get_internal_image_direct(54);
            images_sprite_99_13_0[7] = get_internal_image_direct(54);
            images_sprite_99_13_0[8] = get_internal_image_direct(54);
            images_sprite_99_13_0[9] = get_internal_image_direct(54);
            images_sprite_99_14_0[0] = get_internal_image_direct(80);
            images_sprite_99_14_0[1] = get_internal_image_direct(105);
            images_sprite_99_14_0[2] = get_internal_image_direct(650);
            images_sprite_99_15_0[0] = get_internal_image_direct(711);
            images_sprite_99_15_0[1] = get_internal_image_direct(801);
            images_sprite_99_15_0[2] = get_internal_image_direct(713);
            images_sprite_99_15_16[0] = get_internal_image_direct(816);
            images_sprite_99_15_16[1] = get_internal_image_direct(815);
            images_sprite_99_15_16[2] = get_internal_image_direct(814);
            images_sprite_99_16_0[0] = get_internal_image_direct(646);
            images_sprite_99_16_0[1] = get_internal_image_direct(655);
            images_sprite_99_16_0[2] = get_internal_image_direct(642);
            images_sprite_99_16_0[3] = get_internal_image_direct(655);
            images_sprite_99_16_16[0] = get_internal_image_direct(817);
            images_sprite_99_16_16[1] = get_internal_image_direct(819);
            images_sprite_99_16_16[2] = get_internal_image_direct(823);
            images_sprite_99_16_16[3] = get_internal_image_direct(819);
            images_sprite_99_17_0[0] = get_internal_image_direct(660);
            images_sprite_99_17_16[0] = get_internal_image_direct(820);
            images_sprite_99_18_0[0] = get_internal_image_direct(690);
            images_sprite_99_18_16[0] = get_internal_image_direct(822);
            images_sprite_99_19_0[0] = get_internal_image_direct(692);
            images_sprite_99_19_16[0] = get_internal_image_direct(818);
            images_sprite_99_20_0[0] = get_internal_image_direct(821);
            images_sprite_99_20_16[0] = get_internal_image_direct(824);
            images_sprite_99_21_0[0] = get_internal_image_direct(797);
            images_sprite_99_21_0[1] = get_internal_image_direct(800);
            images_sprite_99_21_0[2] = get_internal_image_direct(647);
            images_sprite_99_21_0[3] = get_internal_image_direct(647);
            images_sprite_99_21_16[0] = get_internal_image_direct(826);
            images_sprite_99_21_16[1] = get_internal_image_direct(827);
            images_sprite_99_21_16[2] = get_internal_image_direct(647);
            images_sprite_99_21_16[3] = get_internal_image_direct(647);
            images_sprite_99_22_0[0] = get_internal_image_direct(645);
            images_sprite_99_22_0[1] = get_internal_image_direct(792);
            images_sprite_99_22_0[2] = get_internal_image_direct(796);
            images_sprite_99_22_0[3] = get_internal_image_direct(794);
            images_sprite_99_22_0[4] = get_internal_image_direct(795);
            images_sprite_99_22_0[5] = get_internal_image_direct(793);
            images_sprite_99_22_16[0] = get_internal_image_direct(802);
            images_sprite_99_22_16[1] = get_internal_image_direct(828);
            images_sprite_99_22_16[2] = get_internal_image_direct(829);
            images_sprite_99_22_16[3] = get_internal_image_direct(830);
            images_sprite_99_22_16[4] = get_internal_image_direct(831);
            images_sprite_99_22_16[5] = get_internal_image_direct(832);
            images_sprite_99_23_0[0] = get_internal_image_direct(970);
            images_sprite_99_23_16[0] = get_internal_image_direct(966);
        }
        active_flags |= TRANSPARENT;
        animation = STOPPED;
        current_animation = animation;
        initialize_active(false);
        set_direction(0);
        create_alterables();
    }
};
FrameObject * create_sprite_99(int x, int y)
{
    return new (Active::pool.create()) Sprite_99(x, y);
}
